#ifndef _WINGDI_H
#define _WINGDI_H
#define _WINGDI_
#if __GNUC__ >= 3
#pragma GCC system_header
#endif

#ifdef __cplusplus
extern "C" {
#endif

#ifndef WINGDIAPI
#ifdef __W32API_USE_DLLIMPORT__
#define WINGDIAPI DECLSPEC_IMPORT
#else
#define WINGDIAPI
#endif
#endif

#define BI_RGB 0
#define BI_RLE8 1
#define BI_RLE4 2
#define BI_BITFIELDS 3
#define BI_JPEG 4
#define BI_PNG 5
#define LF_FACESIZE	32
#define LF_FULLFACESIZE	64
#define CA_NEGATIVE	1
#define CA_LOG_FILTER	2
#define ILLUMINANT_DEVICE_DEFAULT	0
#define ILLUMINANT_A	1
#define ILLUMINANT_B	2
#define ILLUMINANT_C	3
#define ILLUMINANT_D50	4
#define ILLUMINANT_D55	5
#define ILLUMINANT_D65	6
#define ILLUMINANT_D75	7
#define ILLUMINANT_F2	8
#define ILLUMINANT_MAX_INDEX	ILLUMINANT_F2
#define ILLUMINANT_TUNGSTEN	ILLUMINANT_A
#define ILLUMINANT_DAYLIGHT	ILLUMINANT_C
#define ILLUMINANT_FLUORESCENT	ILLUMINANT_F2
#define ILLUMINANT_NTSC	ILLUMINANT_C
#define RGB_GAMMA_MIN	2500
#define RGB_GAMMA_MAX	65000
#define REFERENCE_WHITE_MIN	6000
#define REFERENCE_WHITE_MAX	10000
#define REFERENCE_BLACK_MIN	0
#define REFERENCE_BLACK_MAX	4000
#define COLOR_ADJ_MIN	(-100)
#define COLOR_ADJ_MAX	100
#define CCHDEVICENAME 32
#define CCHFORMNAME 32
#define DI_COMPAT	4
#define DI_DEFAULTSIZE	8
#define DI_IMAGE	2
#define DI_MASK	1
#define DI_NORMAL	3
#define DI_APPBANDING 1
#define EMR_HEADER	1
#define EMR_POLYBEZIER 2
#define EMR_POLYGON	3
#define EMR_POLYLINE	4
#define EMR_POLYBEZIERTO	5
#define EMR_POLYLINETO 6
#define EMR_POLYPOLYLINE	7
#define EMR_POLYPOLYGON 8
#define EMR_SETWINDOWEXTEX	9
#define EMR_SETWINDOWORGEX	10
#define EMR_SETVIEWPORTEXTEX 11
#define EMR_SETVIEWPORTORGEX 12
#define EMR_SETBRUSHORGEX 13
#define EMR_EOF 14
#define EMR_SETPIXELV 15
#define EMR_SETMAPPERFLAGS 16
#define EMR_SETMAPMODE 17
#define EMR_SETBKMODE 18
#define EMR_SETPOLYFILLMODE 19
#define EMR_SETROP2 20
#define EMR_SETSTRETCHBLTMODE 21
#define EMR_SETTEXTALIGN 22
#define EMR_SETCOLORADJUSTMENT 23
#define EMR_SETTEXTCOLOR 24
#define EMR_SETBKCOLOR 25
#define EMR_OFFSETCLIPRGN 26
#define EMR_MOVETOEX 27
#define EMR_SETMETARGN 28
#define EMR_EXCLUDECLIPRECT 29
#define EMR_INTERSECTCLIPRECT 30
#define EMR_SCALEVIEWPORTEXTEX 31
#define EMR_SCALEWINDOWEXTEX 32
#define EMR_SAVEDC 33
#define EMR_RESTOREDC 34
#define EMR_SETWORLDTRANSFORM 35
#define EMR_MODIFYWORLDTRANSFORM 36
#define EMR_SELECTOBJECT 37
#define EMR_CREATEPEN 38
#define EMR_CREATEBRUSHINDIRECT 39
#define EMR_DELETEOBJECT 40
#define EMR_ANGLEARC 41
#define EMR_ELLIPSE  42
#define EMR_RECTANGLE 43
#define EMR_ROUNDRECT 44
#define EMR_ARC 45
#define EMR_CHORD 46
#define EMR_PIE 47
#define EMR_SELECTPALETTE 48
#define EMR_CREATEPALETTE 49
#define EMR_SETPALETTEENTRIES 50
#define EMR_RESIZEPALETTE 51
#define EMR_REALIZEPALETTE 52
#define EMR_EXTFLOODFILL 53
#define EMR_LINETO 54
#define EMR_ARCTO 55
#define EMR_POLYDRAW 56
#define EMR_SETARCDIRECTION 57
#define EMR_SETMITERLIMIT 58
#define EMR_BEGINPATH 59
#define EMR_ENDPATH 60
#define EMR_CLOSEFIGURE 61
#define EMR_FILLPATH 62
#define EMR_STROKEANDFILLPATH 63
#define EMR_STROKEPATH 64
#define EMR_FLATTENPATH 65
#define EMR_WIDENPATH 66
#define EMR_SELECTCLIPPATH 67
#define EMR_ABORTPATH 68
#define EMR_GDICOMMENT 70
#define EMR_FILLRGN 71
#define EMR_FRAMERGN 72
#define EMR_INVERTRGN 73
#define EMR_PAINTRGN 74
#define EMR_EXTSELECTCLIPRGN 75
#define EMR_BITBLT 76
#define EMR_STRETCHBLT 77
#define EMR_MASKBLT 78
#define EMR_PLGBLT 79
#define EMR_SETDIBITSTODEVICE 80
#define EMR_STRETCHDIBITS 81
#define EMR_EXTCREATEFONTINDIRECTW 82
#define EMR_EXTTEXTOUTA 83
#define EMR_EXTTEXTOUTW 84
#define EMR_POLYBEZIER16 85
#define EMR_POLYGON16 86
#define EMR_POLYLINE16 87
#define EMR_POLYBEZIERTO16 88
#define EMR_POLYLINETO16 89
#define EMR_POLYPOLYLINE16 90
#define EMR_POLYPOLYGON16 91
#define EMR_POLYDRAW16 92
#define EMR_CREATEMONOBRUSH 93
#define EMR_CREATEDIBPATTERNBRUSHPT 94
#define EMR_EXTCREATEPEN 95
#define EMR_POLYTEXTOUTA 96
#define EMR_POLYTEXTOUTW 97
#define EMR_SETICMMODE 98
#define EMR_CREATECOLORSPACE 99
#define EMR_SETCOLORSPACE 100
#define EMR_DELETECOLORSPACE 101
#define EMR_GLSRECORD 102
#define EMR_GLSBOUNDEDRECORD 103
#define EMR_PIXELFORMAT 104
#define ENHMETA_SIGNATURE 1179469088
#define EPS_SIGNATURE 0x46535045
#if (_WIN32_WINNT >= 0x0500)
#define FR_PRIVATE 0x10
#define FR_NOT_ENUM 0x20
#endif
#define META_SETBKCOLOR	0x201
#define META_SETBKMODE	0x102
#define META_SETMAPMODE	0x103
#define META_SETROP2	0x104
#define META_SETRELABS	0x105
#define META_SETPOLYFILLMODE	0x106
#define META_SETSTRETCHBLTMODE	0x107
#define META_SETTEXTCHAREXTRA	0x108
#define META_SETTEXTCOLOR	0x209
#define META_SETTEXTJUSTIFICATION	0x20A
#define META_SETWINDOWORG	0x20B
#define META_SETWINDOWEXT	0x20C
#define META_SETVIEWPORTORG	0x20D
#define META_SETVIEWPORTEXT	0x20E
#define META_OFFSETWINDOWORG	0x20F
#define META_SCALEWINDOWEXT	0x410
#define META_OFFSETVIEWPORTORG	0x211
#define META_SCALEVIEWPORTEXT	0x412
#define META_LINETO	0x213
#define META_MOVETO	0x214
#define META_EXCLUDECLIPRECT	0x415
#define META_INTERSECTCLIPRECT	0x416
#define META_ARC	0x817
#define META_ELLIPSE	0x418
#define META_FLOODFILL	0x419
#define META_PIE	0x81A
#define META_RECTANGLE	0x41B
#define META_ROUNDRECT	0x61C
#define META_PATBLT	0x61D
#define META_SAVEDC	0x1E
#define META_SETPIXEL	0x41F
#define META_OFFSETCLIPRGN	0x220
#define META_TEXTOUT	0x521
#define META_BITBLT	0x922
#define META_STRETCHBLT	0xB23
#define META_POLYGON	0x324
#define META_POLYLINE	0x325
#define META_ESCAPE	0x626
#define META_RESTOREDC	0x127
#define META_FILLREGION	0x228
#define META_FRAMEREGION	0x429
#define META_INVERTREGION	0x12A
#define META_PAINTREGION	0x12B
#define META_SELECTCLIPREGION	0x12C
#define META_SELECTOBJECT	0x12D
#define META_SETTEXTALIGN	0x12E
#define META_CHORD	0x830
#define META_SETMAPPERFLAGS	0x231
#define META_EXTTEXTOUT	0xa32
#define META_SETDIBTODEV	0xd33
#define META_SELECTPALETTE	0x234
#define META_REALIZEPALETTE	0x35
#define META_ANIMATEPALETTE	0x436
#define META_SETPALENTRIES	0x37
#define META_POLYPOLYGON	0x538
#define META_RESIZEPALETTE	0x139
#define META_DIBBITBLT	0x940
#define META_DIBSTRETCHBLT	0xb41
#define META_DIBCREATEPATTERNBRUSH	0x142
#define META_STRETCHDIB	0xf43
#define META_EXTFLOODFILL	0x548
#define META_DELETEOBJECT	0x1f0
#define META_CREATEPALETTE	0xf7
#define META_CREATEPATTERNBRUSH	0x1F9
#define META_CREATEPENINDIRECT	0x2FA
#define META_CREATEFONTINDIRECT	0x2FB
#define META_CREATEBRUSHINDIRECT	0x2FC
#define META_CREATEREGION	0x6FF
#define PT_MOVETO	6
#define PT_LINETO	2
#define PT_BEZIERTO	4
#define PT_CLOSEFIGURE 1
#define ELF_VENDOR_SIZE	4
#define ELF_VERSION	0
#define ELF_CULTURE_LATIN	0
#define PFD_TYPE_RGBA	0
#define PFD_TYPE_COLORINDEX	1
#define PFD_MAIN_PLANE	0
#define PFD_OVERLAY_PLANE	1
#define PFD_UNDERLAY_PLANE	(-1)
#define PFD_DOUBLEBUFFER	1
#define PFD_STEREO	2
#define PFD_DRAW_TO_WINDOW	4
#define PFD_DRAW_TO_BITMAP	8
#define PFD_SUPPORT_GDI	16
#define PFD_SUPPORT_OPENGL	32
#define PFD_GENERIC_FORMAT	64
#define PFD_NEED_PALETTE	128
#define PFD_NEED_SYSTEM_PALETTE	0x00000100
#define PFD_SWAP_EXCHANGE	0x00000200
#define PFD_SWAP_COPY	0x00000400
#define PFD_SWAP_LAYER_BUFFERS	0x00000800
#define PFD_GENERIC_ACCELERATED	0x00001000
#define PFD_DEPTH_DONTCARE	0x20000000
#define PFD_DOUBLEBUFFER_DONTCARE	0x40000000
#define PFD_STEREO_DONTCARE	0x80000000
#define SP_ERROR	(-1)
#define SP_OUTOFDISK	(-4)
#define SP_OUTOFMEMORY	(-5)
#define SP_USERABORT	(-3)
#define SP_APPABORT	(-2)
#define BLACKNESS	0x00000042
#define NOTSRCERASE	0x001100A6
#define NOTSRCCOPY	0x00330008
#define SRCERASE	0x00440328
#define DSTINVERT	0x00550009
#define PATINVERT	0x005A0049
#define SRCINVERT	0x00660046
#define SRCAND	0x008800C6
#define MERGEPAINT	0x00BB0226
#define MERGECOPY	0x00C000CA
#define SRCCOPY 0x00CC0020
#define SRCPAINT	0x00EE0086
#define PATCOPY	0x00F00021
#define PATPAINT	0x00FB0A09
#define WHITENESS	0x00FF0062
#define CAPTUREBLT	0x40000000
#define NOMIRRORBITMAP	0x80000000
#define R2_BLACK	1
#define R2_COPYPEN	13
#define R2_MASKNOTPEN	3
#define R2_MASKPEN	9
#define R2_MASKPENNOT	5
#define R2_MERGENOTPEN	12
#define R2_MERGEPEN	15
#define R2_MERGEPENNOT	14
#define R2_NOP	11
#define R2_NOT	6
#define R2_NOTCOPYPEN	4
#define R2_NOTMASKPEN	8
#define R2_NOTMERGEPEN	2
#define R2_NOTXORPEN	10
#define R2_WHITE	16
#define R2_XORPEN	7
#define CM_OUT_OF_GAMUT	255
#define CM_IN_GAMUT	0
#define RGN_AND 1
#define RGN_COPY	5
#define RGN_DIFF	4
#define RGN_OR	2
#define RGN_XOR	3
#define NULLREGION	1
#define SIMPLEREGION	2
#define COMPLEXREGION	3
#define ERROR 0
#define CBM_INIT	4
#define DIB_PAL_COLORS	1
#define DIB_RGB_COLORS	0
#define FW_DONTCARE	0
#define FW_THIN	100
#define FW_EXTRALIGHT	200
#define FW_ULTRALIGHT	FW_EXTRALIGHT
#define FW_LIGHT	300
#define FW_NORMAL	400
#define FW_REGULAR	400
#define FW_MEDIUM	500
#define FW_SEMIBOLD	600
#define FW_DEMIBOLD	FW_SEMIBOLD
#define FW_BOLD	700
#define FW_EXTRABOLD	800
#define FW_ULTRABOLD	FW_EXTRABOLD
#define FW_HEAVY	900
#define FW_BLACK	FW_HEAVY
#define ANSI_CHARSET	0
#define DEFAULT_CHARSET	1
#define SYMBOL_CHARSET	2
#define SHIFTJIS_CHARSET	128
#define HANGEUL_CHARSET	129
#define HANGUL_CHARSET  129
#define GB2312_CHARSET	134
#define CHINESEBIG5_CHARSET	136
#define GREEK_CHARSET	161
#define TURKISH_CHARSET	162
#define HEBREW_CHARSET	177
#define ARABIC_CHARSET	178
#define BALTIC_CHARSET	186
#define RUSSIAN_CHARSET	204
#define THAI_CHARSET	222
#define EASTEUROPE_CHARSET	238
#define OEM_CHARSET	255
#define JOHAB_CHARSET	130
#define VIETNAMESE_CHARSET	163
#define MAC_CHARSET 77
#define OUT_DEFAULT_PRECIS	0
#define OUT_STRING_PRECIS	1
#define OUT_CHARACTER_PRECIS	2
#define OUT_STROKE_PRECIS	3
#define OUT_TT_PRECIS	4
#define OUT_DEVICE_PRECIS	5
#define OUT_RASTER_PRECIS	6
#define OUT_TT_ONLY_PRECIS	7
#define OUT_OUTLINE_PRECIS	8
//http://www.pinvoke.net/default.aspx/Structures/LOGFONT.html
#define OUT_PS_ONLY_PRECIS      10
#define CLIP_DEFAULT_PRECIS	0
#define CLIP_CHARACTER_PRECIS	1
#define CLIP_STROKE_PRECIS	2
#define CLIP_MASK	15
#define CLIP_LH_ANGLES	16
#define CLIP_TT_ALWAYS	32
#define CLIP_EMBEDDED	128
#define DEFAULT_QUALITY	0
#define DRAFT_QUALITY	1
#define PROOF_QUALITY	2
#define NONANTIALIASED_QUALITY 3
#define ANTIALIASED_QUALITY 4
#define DEFAULT_PITCH	0
#define FIXED_PITCH	1
#define VARIABLE_PITCH	2
#define MONO_FONT 8
#define FF_DECORATIVE	80
#define FF_DONTCARE	0
#define FF_MODERN	48
#define FF_ROMAN	16
#define FF_SCRIPT	64
#define FF_SWISS	32
#define PANOSE_COUNT 10
#define PAN_FAMILYTYPE_INDEX 0
#define PAN_SERIFSTYLE_INDEX 1
#define PAN_WEIGHT_INDEX 2
#define PAN_PROPORTION_INDEX 3
#define PAN_CONTRAST_INDEX 4
#define PAN_STROKEVARIATION_INDEX 5
#define PAN_ARMSTYLE_INDEX 6
#define PAN_LETTERFORM_INDEX 7
#define PAN_MIDLINE_INDEX 8
#define PAN_XHEIGHT_INDEX 9
#define PAN_CULTURE_LATIN 0
#define PAN_ANY 0
#define PAN_NO_FIT 1
#define PAN_FAMILY_TEXT_DISPLAY 2
#define PAN_FAMILY_SCRIPT 3
#define PAN_FAMILY_DECORATIVE 4
#define PAN_FAMILY_PICTORIAL 5
#define PAN_SERIF_COVE 2
#define PAN_SERIF_OBTUSE_COVE 3
#define PAN_SERIF_SQUARE_COVE 4
#define PAN_SERIF_OBTUSE_SQUARE_COVE 5
#define PAN_SERIF_SQUARE 6
#define PAN_SERIF_THIN 7
#define PAN_SERIF_BONE 8
#define PAN_SERIF_EXAGGERATED 9
#define PAN_SERIF_TRIANGLE 10
#define PAN_SERIF_NORMAL_SANS 11
#define PAN_SERIF_OBTUSE_SANS 12
#define PAN_SERIF_PERP_SANS 13
#define PAN_SERIF_FLARED 14
#define PAN_SERIF_ROUNDED 15
#define PAN_WEIGHT_VERY_LIGHT 2
#define PAN_WEIGHT_LIGHT 3
#define PAN_WEIGHT_THIN 4
#define PAN_WEIGHT_BOOK 5
#define PAN_WEIGHT_MEDIUM 6
#define PAN_WEIGHT_DEMI 7
#define PAN_WEIGHT_BOLD 8
#define PAN_WEIGHT_HEAVY 9
#define PAN_WEIGHT_BLACK 10
#define PAN_WEIGHT_NORD 11
#define PAN_PROP_OLD_STYLE 2
#define PAN_PROP_MODERN 3
#define PAN_PROP_EVEN_WIDTH 4
#define PAN_PROP_EXPANDED 5
#define PAN_PROP_CONDENSED 6
#define PAN_PROP_VERY_EXPANDED 7
#define PAN_PROP_VERY_CONDENSED 8
#define PAN_PROP_MONOSPACED 9
#define PAN_CONTRAST_NONE 2
#define PAN_CONTRAST_VERY_LOW 3
#define PAN_CONTRAST_LOW 4
#define PAN_CONTRAST_MEDIUM_LOW 5
#define PAN_CONTRAST_MEDIUM 6
#define PAN_CONTRAST_MEDIUM_HIGH 7
#define PAN_CONTRAST_HIGH 8
#define PAN_CONTRAST_VERY_HIGH 9
#define PAN_STROKE_GRADUAL_DIAG 2
#define PAN_STROKE_GRADUAL_TRAN 3
#define PAN_STROKE_GRADUAL_VERT 4
#define PAN_STROKE_GRADUAL_HORZ 5
#define PAN_STROKE_RAPID_VERT 6
#define PAN_STROKE_RAPID_HORZ 7
#define PAN_STROKE_INSTANT_VERT 8
#define PAN_STRAIGHT_ARMS_HORZ 2
#define PAN_STRAIGHT_ARMS_WEDGE 3
#define PAN_STRAIGHT_ARMS_VERT 4
#define PAN_STRAIGHT_ARMS_SINGLE_SERIF 5
#define PAN_STRAIGHT_ARMS_DOUBLE_SERIF 6
#define PAN_BENT_ARMS_HORZ 7
#define PAN_BENT_ARMS_WEDGE 8
#define PAN_BENT_ARMS_VERT 9
#define PAN_BENT_ARMS_SINGLE_SERIF 10
#define PAN_BENT_ARMS_DOUBLE_SERIF 11
#define PAN_LETT_NORMAL_CONTACT 2
#define PAN_LETT_NORMAL_WEIGHTED 3
#define PAN_LETT_NORMAL_BOXED 4
#define PAN_LETT_NORMAL_FLATTENED 5
#define PAN_LETT_NORMAL_ROUNDED 6
#define PAN_LETT_NORMAL_OFF_CENTER 7
#define PAN_LETT_NORMAL_SQUARE 8
#define PAN_LETT_OBLIQUE_CONTACT 9
#define PAN_LETT_OBLIQUE_WEIGHTED 10
#define PAN_LETT_OBLIQUE_BOXED 11
#define PAN_LETT_OBLIQUE_FLATTENED 12
#define PAN_LETT_OBLIQUE_ROUNDED 13
#define PAN_LETT_OBLIQUE_OFF_CENTER 14
#define PAN_LETT_OBLIQUE_SQUARE 15
#define PAN_MIDLINE_STANDARD_TRIMMED 2
#define PAN_MIDLINE_STANDARD_POINTED 3
#define PAN_MIDLINE_STANDARD_SERIFED 4
#define PAN_MIDLINE_HIGH_TRIMMED 5
#define PAN_MIDLINE_HIGH_POINTED 6
#define PAN_MIDLINE_HIGH_SERIFED 7
#define PAN_MIDLINE_CONSTANT_TRIMMED 8
#define PAN_MIDLINE_CONSTANT_POINTED 9
#define PAN_MIDLINE_CONSTANT_SERIFED 10
#define PAN_MIDLINE_LOW_TRIMMED 11
#define PAN_MIDLINE_LOW_POINTED 12
#define PAN_MIDLINE_LOW_SERIFED 13
#define PAN_XHEIGHT_CONSTANT_SMALL 2
#define PAN_XHEIGHT_CONSTANT_STD 3
#define PAN_XHEIGHT_CONSTANT_LARGE 4
#define PAN_XHEIGHT_DUCKING_SMALL 5
#define PAN_XHEIGHT_DUCKING_STD 6
#define PAN_XHEIGHT_DUCKING_LARGE 7
#define FS_LATIN1 1
#define FS_LATIN2 2
#define FS_CYRILLIC 4
#define FS_GREEK 8
#define FS_TURKISH 16
#define FS_HEBREW 32
#define FS_ARABIC 64
#define FS_BALTIC 128
#define FS_THAI 0x10000
#define FS_JISJAPAN 0x20000
#define FS_CHINESESIMP 0x40000
#define FS_WANSUNG 0x80000
#define FS_CHINESETRAD 0x100000
#define FS_JOHAB 0x200000
#define FS_SYMBOL 0x80000000
#define HS_BDIAGONAL	3
#define HS_CROSS	4
#define HS_DIAGCROSS	5
#define HS_FDIAGONAL	2
#define HS_HORIZONTAL	0
#define HS_VERTICAL	1
#define PS_GEOMETRIC	65536
#define PS_COSMETIC	0
#define PS_ALTERNATE	8
#define PS_SOLID	0
#define PS_DASH	1
#define PS_DOT	2
#define PS_DASHDOT	3
#define PS_DASHDOTDOT	4
#define PS_NULL	5
#define PS_USERSTYLE	7
#define PS_INSIDEFRAME	6
#define PS_ENDCAP_ROUND	0
#define PS_ENDCAP_SQUARE	256
#define PS_ENDCAP_FLAT	512
#define PS_JOIN_BEVEL	4096
#define PS_JOIN_MITER	8192
#define PS_JOIN_ROUND	0
#define PS_STYLE_MASK	15
#define PS_ENDCAP_MASK	3840
#define PS_TYPE_MASK	983040
#define ALTERNATE	1
#define WINDING	2
#define DC_BINNAMES	12
#define DC_BINS	6
#define DC_COPIES	18
#define DC_DRIVER	11
#define DC_DATATYPE_PRODUCED	21
#define DC_DUPLEX	7
#define DC_EMF_COMPLIANT	20
#define DC_ENUMRESOLUTIONS	13
#define DC_EXTRA	9
#define DC_FIELDS	1
#define DC_FILEDEPENDENCIES	14
#define DC_MAXEXTENT	5
#define DC_MINEXTENT	4
#define DC_ORIENTATION	17
#define DC_PAPERNAMES	16
#define DC_PAPERS	2
#define DC_PAPERSIZE	3
#define DC_SIZE	8
#define DC_TRUETYPE	15
#define DCTT_BITMAP	1
#define DCTT_DOWNLOAD	2
#define DCTT_SUBDEV	4
#define DCTT_DOWNLOAD_OUTLINE 8
#define DC_VERSION	10
#define DC_BINADJUST	19
#define DC_EMF_COMPLIANT	20
#define DC_DATATYPE_PRODUCED	21
#define DC_MANUFACTURER	23
#define DC_MODEL	24
#if (WINVER >= 0x0500)
#define DC_PERSONALITY	25
#define DC_PRINTRATE	26
#define DC_PRINTRATEUNIT	27
#define DC_PRINTERMEM	28
#define DC_MEDIAREADY	29
#define DC_STAPLE	30
#define DC_PRINTRATEPPM	31
#define DC_COLORDEVICE	32
#define DC_NUP	33
#endif
#if (WINVER >= 0x0501)
#define DC_MEDIATYPENAMES	34
#define DC_MEDIATYPES	35
#endif
#define DCBA_FACEUPNONE	0
#define DCBA_FACEUPCENTER	1
#define DCBA_FACEUPLEFT	2
#define DCBA_FACEUPRIGHT	3
#define DCBA_FACEDOWNNONE	256
#define DCBA_FACEDOWNCENTER	257
#define DCBA_FACEDOWNLEFT	258
#define DCBA_FACEDOWNRIGHT	259
#define FLOODFILLBORDER 0
#define FLOODFILLSURFACE 1
#define ETO_CLIPPED 0x0004
#define ETO_GLYPH_INDEX 0x0010
#define ETO_OPAQUE 0x0002
#define ETO_NUMERICSLATIN 0x0800
#define ETO_NUMERICSLOCAL 0x0400
#define ETO_RTLREADING 0x0080
#if (_WIN32_WINNT >= 0x0400)
#define ETO_IGNORELANGUAGE 0x1000
#endif
#if (_WIN32_WINNT >= 0x0500)
#define ETO_PDY 0x2000
#endif
#define GDICOMMENT_WINDOWS_METAFILE (-2147483647)
#define GDICOMMENT_BEGINGROUP 2
#define GDICOMMENT_ENDGROUP 3
#define GDICOMMENT_MULTIFORMATS 1073741828
#define GDICOMMENT_IDENTIFIER 1128875079
#define AD_COUNTERCLOCKWISE 1
#define AD_CLOCKWISE 2
#define RDH_RECTANGLES	1
#define GCPCLASS_LATIN	1
#define GCPCLASS_HEBREW	2
#define GCPCLASS_ARABIC	2
#define GCPCLASS_NEUTRAL	3
#define GCPCLASS_LOCALNUMBER	4
#define GCPCLASS_LATINNUMBER	5
#define GCPCLASS_LATINNUMERICTERMINATOR	6
#define GCPCLASS_LATINNUMERICSEPARATOR	7
#define GCPCLASS_NUMERICSEPARATOR	8
#define GCPCLASS_PREBOUNDLTR	128
#define GCPCLASS_PREBOUNDRTL	64
#define GCPCLASS_POSTBOUNDLTR	32
#define GCPCLASS_POSTBOUNDRTL	16
#define GCPGLYPH_LINKBEFORE	0x8000
#define GCPGLYPH_LINKAFTER	0x4000
#define DCB_DISABLE 8
#define DCB_ENABLE 4
#define DCB_RESET 1
#define DCB_SET 3
#define DCB_ACCUMULATE 2
#define DCB_DIRTY	2
#define OBJ_BRUSH 2
#define OBJ_PEN 1
#define OBJ_PAL 5
#define OBJ_FONT 6
#define OBJ_BITMAP 7
#define OBJ_EXTPEN 11
#define OBJ_REGION 8
#define OBJ_DC 3
#define OBJ_MEMDC 10
#define OBJ_METAFILE 9
#define OBJ_METADC 4
#define OBJ_ENHMETAFILE 13
#define OBJ_ENHMETADC 12
#define DRIVERVERSION 0
#define TECHNOLOGY 2
#define DT_PLOTTER 0
#define DT_RASDISPLAY 1
#define DT_RASPRINTER 2
#define DT_RASCAMERA 3
#define DT_CHARSTREAM 4
#define DT_METAFILE 5
#define DT_DISPFILE 6
#define HORZSIZE 4
#define VERTSIZE 6
#define HORZRES 8
#define VERTRES 10
#define LOGPIXELSX 88
#define LOGPIXELSY 90
#define BITSPIXEL 12
#define PLANES 14
#define NUMBRUSHES 16
#define NUMPENS 18
#define NUMFONTS 22
#define NUMCOLORS 24
#define NUMMARKERS 20
#define ASPECTX 40
#define ASPECTY 42
#define ASPECTXY 44
#define PDEVICESIZE 26
#define CLIPCAPS 36
#define SIZEPALETTE 104
#define NUMRESERVED 106
#define COLORRES 108
#define PHYSICALWIDTH 110
#define PHYSICALHEIGHT 111
#define PHYSICALOFFSETX 112
#define PHYSICALOFFSETY 113
#define SCALINGFACTORX 114
#define SCALINGFACTORY 115
#define VREFRESH 116
#define DESKTOPHORZRES 118
#define DESKTOPVERTRES 117
#define BLTALIGNMENT 119
#if(WINVER >= 0x0500)
#define SHADEBLENDCAPS 120
#define SB_NONE 0x00
#define SB_CONST_ALPHA 0x01
#define SB_PIXEL_ALPHA 0x02
#define SB_PREMULT_ALPHA 0x04
#define SB_GRAD_RECT 0x10
#define SB_GRAD_TRI 0x20
#define COLORMGMTCAPS 121
#define CM_NONE 0x00
#define CM_DEVICE_ICM 0x01
#define CM_GAMMA_RAMP 0x02
#define CM_CMYK_COLOR 0x04
#endif
#define RASTERCAPS 38
#define RC_BANDING 2
#define RC_BITBLT 1
#define RC_BITMAP64 8
#define RC_DI_BITMAP 128
#define RC_DIBTODEV 512
#define RC_FLOODFILL 4096
#define RC_GDI20_OUTPUT 16
#define RC_PALETTE 256
#define RC_SCALING 4
#define RC_STRETCHBLT 2048
#define RC_STRETCHDIB 8192
#define RC_DEVBITS 0x8000
#define RC_OP_DX_OUTPUT 0x4000
#define CURVECAPS 28
#define CC_NONE 0
#define CC_CIRCLES 1
#define CC_PIE 2
#define CC_CHORD 4
#define CC_ELLIPSES 8
#define CC_WIDE 16
#define CC_STYLED 32
#define CC_WIDESTYLED 64
#define CC_INTERIORS 128
#define CC_ROUNDRECT 256
#define LINECAPS 30
#define LC_NONE 0
#define LC_POLYLINE 2
#define LC_MARKER 4
#define LC_POLYMARKER 8
#define LC_WIDE 16
#define LC_STYLED 32
#define LC_WIDESTYLED 64
#define LC_INTERIORS 128
#define POLYGONALCAPS 32
#define RC_BANDING 2
#define RC_BIGFONT 1024
#define RC_BITBLT 1
#define RC_BITMAP64 8
#define RC_DEVBITS 0x8000
#define RC_DI_BITMAP 128
#define RC_GDI20_OUTPUT 16
#define RC_GDI20_STATE 32
#define RC_NONE 0
#define RC_OP_DX_OUTPUT 0x4000
#define RC_PALETTE 256
#define RC_SAVEBITMAP 64
#define RC_SCALING 4
#define PC_NONE 0
#define PC_POLYGON 1
#define PC_POLYPOLYGON 256
#define PC_PATHS 512
#define PC_RECTANGLE 2
#define PC_WINDPOLYGON 4
#define PC_SCANLINE 8
#define PC_TRAPEZOID 4
#define PC_WIDE 16
#define PC_STYLED 32
#define PC_WIDESTYLED 64
#define PC_INTERIORS 128
#define PC_PATHS 512
#define TEXTCAPS 34
#define TC_OP_CHARACTER 1
#define TC_OP_STROKE 2
#define TC_CP_STROKE 4
#define TC_CR_90 8
#define TC_CR_ANY 16
#define TC_SF_X_YINDEP 32
#define TC_SA_DOUBLE 64
#define TC_SA_INTEGER 128
#define TC_SA_CONTIN 256
#define TC_EA_DOUBLE 512
#define TC_IA_ABLE 1024
#define TC_UA_ABLE 2048
#define TC_SO_ABLE 4096
#define TC_RA_ABLE 8192
#define TC_VA_ABLE 16384
#define TC_RESERVED 32768
#define TC_SCROLLBLT 65536
#define GCP_DBCS 1
#define GCP_ERROR 0x8000
#define GCP_CLASSIN 0x80000
#define GCP_DIACRITIC 256
#define GCP_DISPLAYZWG 0x400000
#define GCP_GLYPHSHAPE 16
#define GCP_JUSTIFY 0x10000
#define GCP_JUSTIFYIN 0x200000
#define GCP_KASHIDA 1024
#define GCP_LIGATE 32
#define GCP_MAXEXTENT 0x100000
#define GCP_NEUTRALOVERRIDE 0x2000000
#define GCP_NUMERICOVERRIDE 0x1000000
#define GCP_NUMERICSLATIN 0x4000000
#define GCP_NUMERICSLOCAL 0x8000000
#define GCP_REORDER 2
#define GCP_SYMSWAPOFF 0x800000
#define GCP_USEKERNING 8
#define FLI_GLYPHS 0x40000
#define FLI_MASK 0x103b
#define GGO_METRICS 0
#define GGO_BITMAP 1
#define GGO_NATIVE 2
#define GGO_BEZIER 3
#define GGO_GRAY2_BITMAP 4
#define GGO_GRAY4_BITMAP 5
#define GGO_GRAY8_BITMAP 6
#define GGO_GLYPH_INDEX 128
#if (WINVER >= 0x0500)
#define GGO_UNHINTED 256
#endif
#define GM_COMPATIBLE 1
#define GM_ADVANCED 2
#define MM_ANISOTROPIC 8
#define MM_HIENGLISH 5
#define MM_HIMETRIC 3
#define MM_ISOTROPIC 7
#define MM_LOENGLISH 4
#define MM_LOMETRIC 2
#define MM_TEXT 1
#define MM_TWIPS 6
#define MM_MAX_FIXEDSCALE	MM_TWIPS
#define ABSOLUTE	1
#define RELATIVE	2
#define PC_EXPLICIT 2
#define PC_NOCOLLAPSE 4
#define PC_RESERVED 1
#define CLR_NONE 0xffffffff
#define CLR_INVALID CLR_NONE
#define CLR_DEFAULT 0xff000000
#define PT_MOVETO 6
#define PT_LINETO 2
#define PT_BEZIERTO 4
#define PT_CLOSEFIGURE 1
#define TT_AVAILABLE 1
#define TT_ENABLED 2
#define BLACK_BRUSH 4
#define DKGRAY_BRUSH 3
#define GRAY_BRUSH 2
#define HOLLOW_BRUSH 5
#define LTGRAY_BRUSH 1
#define NULL_BRUSH 5
#define WHITE_BRUSH 0
#define BLACK_PEN 7
#define NULL_PEN 8
#define WHITE_PEN 6
#define ANSI_FIXED_FONT 11
#define ANSI_VAR_FONT 12
#define DEVICE_DEFAULT_FONT 14
#define DEFAULT_GUI_FONT 17
#define OEM_FIXED_FONT 10
#define SYSTEM_FONT 13
#define SYSTEM_FIXED_FONT 16
#define DEFAULT_PALETTE 15
#if (_WIN32_WINNT >= 0x0500)
#define DC_BRUSH	18
#define DC_PEN	19
#endif
#define SYSPAL_ERROR 0
#define SYSPAL_STATIC 1
#define SYSPAL_NOSTATIC 2
#define SYSPAL_NOSTATIC256 3 
#define TA_BASELINE 24
#define TA_BOTTOM 8
#define TA_TOP 0
#define TA_CENTER 6
#define TA_LEFT 0
#define TA_RIGHT 2
#define TA_RTLREADING 256
#define TA_NOUPDATECP 0
#define TA_UPDATECP 1
#define TA_MASK (TA_BASELINE+TA_CENTER+TA_UPDATECP+TA_RTLREADING)
#define VTA_BASELINE 24
#define VTA_CENTER 6
#define VTA_LEFT TA_BOTTOM
#define VTA_RIGHT TA_TOP
#define VTA_BOTTOM TA_RIGHT
#define VTA_TOP TA_LEFT
#define MWT_IDENTITY 1
#define MWT_LEFTMULTIPLY 2
#define MWT_RIGHTMULTIPLY 3
#define OPAQUE 2
#define TRANSPARENT 1
#define BLACKONWHITE 1
#define WHITEONBLACK 2
#define COLORONCOLOR 3
#define HALFTONE 4
#define MAXSTRETCHBLTMODE 4
#define STRETCH_ANDSCANS 1
#define STRETCH_DELETESCANS 3
#define STRETCH_HALFTONE 4
#define STRETCH_ORSCANS 2
#define TCI_SRCCHARSET 1
#define TCI_SRCCODEPAGE 2
#define TCI_SRCFONTSIG 3
#define ICM_ON 2
#define ICM_OFF 1
#define ICM_QUERY 3
#define NEWFRAME	1
#define ABORTDOC	2
#define NEXTBAND	3
#define SETCOLORTABLE	4
#define GETCOLORTABLE	5
#define FLUSHOUTPUT	6
#define DRAFTMODE	7
#define QUERYESCSUPPORT	8
#define SETABORTPROC	9
#define STARTDOC	10
#define ENDDOC	11
#define GETPHYSPAGESIZE	12
#define GETPRINTINGOFFSET	13
#define GETSCALINGFACTOR	14
#define MFCOMMENT	15
#define GETPENWIDTH	16
#define SETCOPYCOUNT	17
#define SELECTPAPERSOURCE	18
#define DEVICEDATA	19
#define PASSTHROUGH	19
#define GETTECHNOLGY	20
#define GETTECHNOLOGY	20
#define SETLINECAP	21
#define SETLINEJOIN	22
#define SETMITERLIMIT	23
#define BANDINFO	24
#define DRAWPATTERNRECT	25
#define GETVECTORPENSIZE	26
#define GETVECTORBRUSHSIZE	27
#define ENABLEDUPLEX	28
#define GETSETPAPERBINS	29
#define GETSETPRINTORIENT	30
#define ENUMPAPERBINS	31
#define SETDIBSCALING	32
#define EPSPRINTING	33
#define ENUMPAPERMETRICS	34
#define GETSETPAPERMETRICS	35
#define POSTSCRIPT_DATA	37
#define POSTSCRIPT_IGNORE	38
#define MOUSETRAILS	39
#define GETDEVICEUNITS	42
#define GETEXTENDEDTEXTMETRICS	256
#define GETEXTENTTABLE	257
#define GETPAIRKERNTABLE	258
#define GETTRACKKERNTABLE	259
#define EXTTEXTOUT	512
#define GETFACENAME	513
#define DOWNLOADFACE	514
#define ENABLERELATIVEWIDTHS	768
#define ENABLEPAIRKERNING	769
#define SETKERNTRACK	770
#define SETALLJUSTVALUES	771
#define SETCHARSET	772
#define STRETCHBLT	2048
#define GETSETSCREENPARAMS	3072
#define QUERYDIBSUPPORT	3073
#define BEGIN_PATH	4096
#define CLIP_TO_PATH	4097
#define END_PATH	4098
#define EXT_DEVICE_CAPS	4099
#define RESTORE_CTM	4100
#define SAVE_CTM	4101
#define SET_ARC_DIRECTION	4102
#define SET_BACKGROUND_COLOR	4103
#define SET_POLY_MODE	4104
#define SET_SCREEN_ANGLE	4105
#define SET_SPREAD	4106
#define TRANSFORM_CTM	4107
#define SET_CLIP_BOX	4108
#define SET_BOUNDS	4109
#define SET_MIRROR_MODE	4110
#define OPENCHANNEL	4110
#define DOWNLOADHEADER	4111
#define CLOSECHANNEL	4112
#define POSTSCRIPT_PASSTHROUGH	4115
#define ENCAPSULATED_POSTSCRIPT	4116
#define QDI_SETDIBITS	1
#define QDI_GETDIBITS	2
#define QDI_DIBTOSCREEN	4
#define QDI_STRETCHDIB	8
#define SP_NOTREPORTED	0x4000
#define PR_JOBSTATUS	0
#define ASPECT_FILTERING	1
#define BS_SOLID	0
#define BS_NULL	1
#define BS_HOLLOW	1
#define BS_HATCHED	2
#define BS_PATTERN	3
#define BS_INDEXED	4
#define BS_DIBPATTERN	5
#define BS_DIBPATTERNPT	6
#define BS_PATTERN8X8	7
#define BS_DIBPATTERN8X8	8
#define LCS_CALIBRATED_RGB	0
#define LCS_DEVICE_RGB	1
#define LCS_DEVICE_CMYK	2
#define LCS_GM_BUSINESS	1
#define LCS_GM_GRAPHICS	2
#define LCS_GM_IMAGES	4
#define RASTER_FONTTYPE	1
#define DEVICE_FONTTYPE	2
#define TRUETYPE_FONTTYPE	4
#define DMORIENT_PORTRAIT   1
#define DMORIENT_LANDSCAPE  2
#define DMPAPER_FIRST	1
#define DMPAPER_LETTER	1
#define DMPAPER_LETTERSMALL	2
#define DMPAPER_TABLOID	3
#define DMPAPER_LEDGER	4
#define DMPAPER_LEGAL	5
#define DMPAPER_STATEMENT	6
#define DMPAPER_EXECUTIVE	7
#define DMPAPER_A3	8
#define DMPAPER_A4	9
#define DMPAPER_A4SMALL	10
#define DMPAPER_A5	11
#define DMPAPER_B4	12
#define DMPAPER_B5	13
#define DMPAPER_FOLIO	14
#define DMPAPER_QUARTO	15
#define DMPAPER_10X14	16
#define DMPAPER_11X17	17
#define DMPAPER_NOTE	18
#define DMPAPER_ENV_9	19
#define DMPAPER_ENV_10	20
#define DMPAPER_ENV_11	21
#define DMPAPER_ENV_12	22
#define DMPAPER_ENV_14	23
#define DMPAPER_CSHEET	24
#define DMPAPER_DSHEET	25
#define DMPAPER_ESHEET	26
#define DMPAPER_ENV_DL	27
#define DMPAPER_ENV_C5	28
#define DMPAPER_ENV_C3	29
#define DMPAPER_ENV_C4	30
#define DMPAPER_ENV_C6	31
#define DMPAPER_ENV_C65	32
#define DMPAPER_ENV_B4	33
#define DMPAPER_ENV_B5	34
#define DMPAPER_ENV_B6	35
#define DMPAPER_ENV_ITALY	36
#define DMPAPER_ENV_MONARCH	37
#define DMPAPER_ENV_PERSONAL	38
#define DMPAPER_FANFOLD_US	39
#define DMPAPER_FANFOLD_STD_GERMAN	40
#define DMPAPER_FANFOLD_LGL_GERMAN	41
#define DMPAPER_ISO_B4	42
#define DMPAPER_JAPANESE_POSTCARD	43
#define DMPAPER_9X11	44
#define DMPAPER_10X11	45
#define DMPAPER_15X11	46
#define DMPAPER_ENV_INVITE	47
#define DMPAPER_RESERVED_48	48
#define DMPAPER_RESERVED_49	49
#define DMPAPER_LETTER_EXTRA	50
#define DMPAPER_LEGAL_EXTRA	51
#define DMPAPER_TABLOID_EXTRA	52
#define DMPAPER_A4_EXTRA	53
#define DMPAPER_LETTER_TRANSVERSE	54
#define DMPAPER_A4_TRANSVERSE	55
#define DMPAPER_LETTER_EXTRA_TRANSVERSE	56
#define DMPAPER_A_PLUS	57
#define DMPAPER_B_PLUS	58
#define DMPAPER_LETTER_PLUS	59
#define DMPAPER_A4_PLUS	60
#define DMPAPER_A5_TRANSVERSE	61
#define DMPAPER_B5_TRANSVERSE	62
#define DMPAPER_A3_EXTRA	63
#define DMPAPER_A5_EXTRA	64
#define DMPAPER_B5_EXTRA	65
#define DMPAPER_A2	66
#define DMPAPER_A3_TRANSVERSE	67
#define DMPAPER_A3_EXTRA_TRANSVERSE	68
#if (WINVER >= 0x0500)
#define DMPAPER_DBL_JAPANESE_POSTCARD	69
#define DMPAPER_A6	70
#define DMPAPER_JENV_KAKU2	71
#define DMPAPER_JENV_KAKU3	72
#define DMPAPER_JENV_CHOU3	73
#define DMPAPER_JENV_CHOU4	74
#define DMPAPER_LETTER_ROTATED	75
#define DMPAPER_A3_ROTATED	76
#define DMPAPER_A4_ROTATED	77
#define DMPAPER_A5_ROTATED	78
#define DMPAPER_B4_JIS_ROTATED	79
#define DMPAPER_B5_JIS_ROTATED	80
#define DMPAPER_JAPANESE_POSTCARD_ROTATED	81
#define DMPAPER_DBL_JAPANESE_POSTCARD_ROTATED	82
#define DMPAPER_A6_ROTATED	83
#define DMPAPER_JENV_KAKU2_ROTATED	84
#define DMPAPER_JENV_KAKU3_ROTATED	85
#define DMPAPER_JENV_CHOU3_ROTATED	86
#define DMPAPER_JENV_CHOU4_ROTATED	87
#define DMPAPER_B6_JIS	88
#define DMPAPER_B6_JIS_ROTATED	89
#define DMPAPER_12X11	90
#define DMPAPER_JENV_YOU4	91
#define DMPAPER_JENV_YOU4_ROTATED	92
#define DMPAPER_P16K	93
#define DMPAPER_P32K	94
#define DMPAPER_P32KBIG	95
#define DMPAPER_PENV_1	96
#define DMPAPER_PENV_2	97
#define DMPAPER_PENV_3	98
#define DMPAPER_PENV_4	99
#define DMPAPER_PENV_5	100
#define DMPAPER_PENV_6	101
#define DMPAPER_PENV_7	102
#define DMPAPER_PENV_8	103
#define DMPAPER_PENV_9	104
#define DMPAPER_PENV_10	105
#define DMPAPER_P16K_ROTATED	106
#define DMPAPER_P32K_ROTATED	107
#define DMPAPER_P32KBIG_ROTATED	108
#define DMPAPER_PENV_1_ROTATED	109
#define DMPAPER_PENV_2_ROTATED	110
#define DMPAPER_PENV_3_ROTATED	111
#define DMPAPER_PENV_4_ROTATED	112
#define DMPAPER_PENV_5_ROTATED	113
#define DMPAPER_PENV_6_ROTATED	114
#define DMPAPER_PENV_7_ROTATED	115
#define DMPAPER_PENV_8_ROTATED	116
#define DMPAPER_PENV_9_ROTATED	117
#define DMPAPER_PENV_10_ROTATED	118
#define DMPAPER_LAST	118
#else
#define DMPAPER_LAST	68
#endif
#define DMPAPER_USER	256
#define DMBIN_FIRST	1
#define DMBIN_UPPER	1
#define DMBIN_ONLYONE	1
#define DMBIN_LOWER	2
#define DMBIN_MIDDLE	3
#define DMBIN_MANUAL	4
#define DMBIN_ENVELOPE	5
#define DMBIN_ENVMANUAL	6
#define DMBIN_AUTO	7
#define DMBIN_TRACTOR	8
#define DMBIN_SMALLFMT	9
#define DMBIN_LARGEFMT	10
#define DMBIN_LARGECAPACITY	11
#define DMBIN_CASSETTE	14
#define DMBIN_FORMSOURCE	15
#define DMBIN_LAST	15
#define DMBIN_USER	256
#define DMRES_DRAFT	(-1)
#define DMRES_LOW	(-2)
#define DMRES_MEDIUM	(-3)
#define DMRES_HIGH	(-4)
#define DMCOLOR_MONOCHROME	1
#define DMCOLOR_COLOR	2
#define DMDUP_SIMPLEX	1
#define DMDUP_VERTICAL	2
#define DMDUP_HORIZONTAL	3
#define DMTT_BITMAP	1
#define DMTT_DOWNLOAD	2
#define DMTT_SUBDEV	3
#define DMTT_DOWNLOAD_OUTLINE	4
#define DMCOLLATE_FALSE	0
#define DMCOLLATE_TRUE	1
#define DM_SPECVERSION	800
#define DM_GRAYSCALE	1
#define DM_INTERLACED	2
#define DM_UPDATE	1
#define DM_COPY	2
#define DM_PROMPT	4
#define DM_MODIFY	8
#define DM_IN_BUFFER	DM_MODIFY
#define DM_IN_PROMPT	DM_PROMPT
#define DM_OUT_BUFFER	DM_COPY
#define DM_OUT_DEFAULT	DM_UPDATE
#define DM_ORIENTATION 0x00000001
#define DM_PAPERSIZE 0x00000002
#define DM_PAPERLENGTH 0x00000004
#define DM_PAPERWIDTH 0x00000008
#define DM_SCALE 0x00000010
#define DM_POSITION 0x00000020
#define DM_COPIES 0x00000100
#define DM_DEFAULTSOURCE 0x00000200
#define DM_PRINTQUALITY 0x00000400
#define DM_COLOR 0x00000800
#define DM_DUPLEX 0x00001000
#define DM_YRESOLUTION 0x00002000
#define DM_TTOPTION 0x00004000
#define DM_COLLATE 0x00008000
#define DM_FORMNAME 0x00010000
#define DM_LOGPIXELS 0x00020000
#define DM_BITSPERPEL 0x00040000
#define DM_PELSWIDTH 0x00080000
#define DM_PELSHEIGHT 0x00100000
#define DM_DISPLAYFLAGS 0x00200000
#define DM_DISPLAYFREQUENCY 0x00400000
#define DM_ICMMETHOD 0x00800000
#define DM_ICMINTENT 0x01000000
#define DM_MEDIATYPE 0x02000000
#define DM_DITHERTYPE 0x04000000
#if(WINVER >= 0x0500)
#define DM_PANNINGWIDTH 0x08000000
#define DM_PANNINGHEIGHT 0x10000000
#endif
#if(WINVER >= 0x0501)
#define DM_DISPLAYFIXEDOUTPUT 0x20000000
#define DM_DISPLAYORIENTATION 0x00000080
#define DMDO_DEFAULT 0x00000000
#define DMDO_90 0x00000001
#define DMDO_180 0x00000002
#define DMDO_270 0x00000003
#define DMDFO_DEFAULT 0x00000000
#define DMDFO_STRETCH 0x00000001
#define DMDFO_CENTER 0x00000002
#endif
#define DMICMMETHOD_NONE	1
#define DMICMMETHOD_SYSTEM	2
#define DMICMMETHOD_DRIVER	3
#define DMICMMETHOD_DEVICE	4
#define DMICMMETHOD_USER	256
#define DMICM_SATURATE	1
#define DMICM_CONTRAST	2
#define DMICM_COLORMETRIC	3
#define DMICM_USER	256
#define DMMEDIA_STANDARD	1
#define DMMEDIA_TRANSPARENCY	2
#define DMMEDIA_GLOSSY	3
#define DMMEDIA_USER	256
#define DMDITHER_NONE	1
#define DMDITHER_COARSE	2
#define DMDITHER_FINE	3
#define DMDITHER_LINEART	4
#define DMDITHER_ERRORDIFFUSION	5
#define DMDITHER_RESERVED6	6
#define DMDITHER_RESERVED7	7
#define DMDITHER_RESERVED8	8
#define DMDITHER_RESERVED9	9
#define DMDITHER_GRAYSCALE	10
#define DMDITHER_USER	256
#define GDI_ERROR 0xFFFFFFFF
#define HGDI_ERROR ((HANDLE)GDI_ERROR)
#define TMPF_FIXED_PITCH 1
#define TMPF_VECTOR 2
#define TMPF_TRUETYPE 4
#define TMPF_DEVICE 8
#define NTM_ITALIC 1
#define NTM_BOLD 32
#define NTM_REGULAR 64
#define TT_POLYGON_TYPE 24
#define TT_PRIM_LINE 1
#define TT_PRIM_QSPLINE 2
#define TT_PRIM_CSPLINE 3 
#define FONTMAPPER_MAX 10
#define ENHMETA_STOCK_OBJECT 0x80000000
#define WGL_FONT_LINES 0
#define WGL_FONT_POLYGONS 1
#define LPD_DOUBLEBUFFER 1
#define LPD_STEREO 2
#define LPD_SUPPORT_GDI 16
#define LPD_SUPPORT_OPENGL 32
#define LPD_SHARE_DEPTH 64
#define LPD_SHARE_STENCIL 128
#define LPD_SHARE_ACCUM 256
#define LPD_SWAP_EXCHANGE 512
#define LPD_SWAP_COPY 1024
#define LPD_TRANSPARENT 4096
#define LPD_TYPE_RGBA 0
#define LPD_TYPE_COLORINDEX 1
#define WGL_SWAP_MAIN_PLANE 1
#define WGL_SWAP_OVERLAY1 2
#define WGL_SWAP_OVERLAY2 4
#define WGL_SWAP_OVERLAY3 8
#define WGL_SWAP_OVERLAY4 16
#define WGL_SWAP_OVERLAY5 32
#define WGL_SWAP_OVERLAY6 64
#define WGL_SWAP_OVERLAY7 128
#define WGL_SWAP_OVERLAY8 256
#define WGL_SWAP_OVERLAY9 512
#define WGL_SWAP_OVERLAY10 1024
#define WGL_SWAP_OVERLAY11 2048
#define WGL_SWAP_OVERLAY12 4096
#define WGL_SWAP_OVERLAY13 8192
#define WGL_SWAP_OVERLAY14 16384
#define WGL_SWAP_OVERLAY15 32768
#define WGL_SWAP_UNDERLAY1 65536
#define WGL_SWAP_UNDERLAY2 0x20000
#define WGL_SWAP_UNDERLAY3 0x40000
#define WGL_SWAP_UNDERLAY4 0x80000
#define WGL_SWAP_UNDERLAY5 0x100000
#define WGL_SWAP_UNDERLAY6 0x200000
#define WGL_SWAP_UNDERLAY7 0x400000
#define WGL_SWAP_UNDERLAY8 0x800000
#define WGL_SWAP_UNDERLAY9 0x1000000
#define WGL_SWAP_UNDERLAY10 0x2000000
#define WGL_SWAP_UNDERLAY11 0x4000000
#define WGL_SWAP_UNDERLAY12 0x8000000
#define WGL_SWAP_UNDERLAY13 0x10000000
#define WGL_SWAP_UNDERLAY14 0x20000000
#define WGL_SWAP_UNDERLAY15 0x40000000
#define AC_SRC_OVER		0x00
#define AC_SRC_ALPHA		0x01
#define AC_SRC_NO_PREMULT_ALPHA	0x01
#define AC_SRC_NO_ALPHA		0x02
#define AC_DST_NO_PREMULT_ALPHA	0x10
#define AC_DST_NO_ALPHA		0x20
#define LAYOUT_RTL 1
#define LAYOUT_BITMAPORIENTATIONPRESERVED 8
#if (WINVER >= 0x0400)
#define CS_ENABLE           0x00000001
#define CS_DISABLE          0x00000002
#define CS_DELETE_TRANSFORM 0x00000003
#endif
#if (WINVER >= 0x0500)
#define GRADIENT_FILL_RECT_H 0x00
#define GRADIENT_FILL_RECT_V 0x01
#define GRADIENT_FILL_TRIANGLE 0x02
#define GRADIENT_FILL_OP_FLAG 0xff
#define COLORMATCHTOTARGET_EMBEDED 0x00000001
#define CREATECOLORSPACE_EMBEDED   0x00000001
#define SETICMPROFILE_EMBEDED      0x00000001
#endif

#define DISPLAY_DEVICE_ATTACHED_TO_DESKTOP 0x00000001
#define DISPLAY_DEVICE_MULTI_DRIVER        0x00000002
#define DISPLAY_DEVICE_PRIMARY_DEVICE      0x00000004
#define DISPLAY_DEVICE_MIRRORING_DRIVER    0x00000008
#define DISPLAY_DEVICE_VGA_COMPATIBLE      0x00000010
#define DISPLAY_DEVICE_REMOVABLE           0x00000020
#define DISPLAY_DEVICE_MODESPRUNED         0x08000000

#if (_WIN32_WINNT >= 0x0500)
#define NTM_NONNEGATIVE_AC  0x00010000
#define NTM_PS_OPENTYPE     0x00020000
#define NTM_TT_OPENTYPE     0x00040000
#define NTM_MULTIPLEMASTER  0x00080000
#define NTM_TYPE1           0x00100000
#define NTM_DSIG            0x00200000
#endif

#if (_WIN32_WINNT >= 0x0500)
#define GGI_MARK_NONEXISTING_GLYPHS 1
#endif

#ifndef RC_INVOKED
typedef struct _ABC {
	int abcA;
	UINT abcB;
	int abcC;
} ABC,*LPABC;
typedef struct _ABCFLOAT {
	FLOAT abcfA;
	FLOAT abcfB;
	FLOAT abcfC;
} ABCFLOAT,*LPABCFLOAT;
typedef struct tagBITMAP {
	LONG	bmType;
	LONG	bmWidth;
	LONG	bmHeight;
	LONG	bmWidthBytes;
	WORD	bmPlanes;
	WORD	bmBitsPixel;
	LPVOID	bmBits;
} BITMAP,*PBITMAP,*LPBITMAP;
typedef struct tagBITMAPCOREHEADER {
	DWORD	bcSize;
	WORD	bcWidth;
	WORD	bcHeight;
	WORD	bcPlanes;
	WORD	bcBitCount;
} BITMAPCOREHEADER,*LPBITMAPCOREHEADER,*PBITMAPCOREHEADER;
#pragma pack(push,1)
typedef struct tagRGBTRIPLE {
	BYTE rgbtBlue;
	BYTE rgbtGreen;
	BYTE rgbtRed;
} RGBTRIPLE,*LPRGBTRIPLE;
#pragma pack(pop)
#pragma pack(push,2)
typedef struct tagBITMAPFILEHEADER {
	WORD	bfType;
	DWORD	bfSize;
	WORD	bfReserved1;
	WORD	bfReserved2;
	DWORD	bfOffBits;
} BITMAPFILEHEADER,*LPBITMAPFILEHEADER,*PBITMAPFILEHEADER;
#pragma pack(pop)
typedef struct _BITMAPCOREINFO {
	BITMAPCOREHEADER	bmciHeader;
	RGBTRIPLE	bmciColors[1];
} BITMAPCOREINFO,*LPBITMAPCOREINFO,*PBITMAPCOREINFO;
typedef struct tagBITMAPINFOHEADER{
	DWORD	biSize;
	LONG	biWidth;
	LONG	biHeight;
	WORD	biPlanes;
	WORD	biBitCount;
	DWORD	biCompression;
	DWORD	biSizeImage;
	LONG	biXPelsPerMeter;
	LONG	biYPelsPerMeter;
	DWORD	biClrUsed;
	DWORD	biClrImportant;
} BITMAPINFOHEADER,*LPBITMAPINFOHEADER,*PBITMAPINFOHEADER;
typedef struct tagRGBQUAD {
	BYTE	rgbBlue;
	BYTE	rgbGreen;
	BYTE	rgbRed;
	BYTE	rgbReserved;
} RGBQUAD,*LPRGBQUAD;
typedef struct tagBITMAPINFO {
	BITMAPINFOHEADER bmiHeader;
	RGBQUAD bmiColors[1];
} BITMAPINFO,*LPBITMAPINFO,*PBITMAPINFO;
typedef long FXPT16DOT16,*LPFXPT16DOT16;
typedef long FXPT2DOT30,*LPFXPT2DOT30;
typedef struct tagCIEXYZ {
	FXPT2DOT30 ciexyzX;
	FXPT2DOT30 ciexyzY;
	FXPT2DOT30 ciexyzZ;
} CIEXYZ,*LPCIEXYZ;
typedef struct tagCIEXYZTRIPLE {
	CIEXYZ ciexyzRed;
	CIEXYZ ciexyzGreen;
	CIEXYZ ciexyzBlue;
} CIEXYZTRIPLE,*LPCIEXYZTRIPLE;
typedef struct {
	DWORD	bV4Size;
	LONG	bV4Width;
	LONG	bV4Height;
	WORD	bV4Planes;
	WORD	bV4BitCount;
	DWORD	bV4V4Compression;
	DWORD	bV4SizeImage;
	LONG	bV4XPelsPerMeter;
	LONG	bV4YPelsPerMeter;
	DWORD	bV4ClrUsed;
	DWORD	bV4ClrImportant;
	DWORD	bV4RedMask;
	DWORD	bV4GreenMask;
	DWORD	bV4BlueMask;
	DWORD	bV4AlphaMask;
	DWORD	bV4CSType;
	CIEXYZTRIPLE bV4Endpoints;
	DWORD	bV4GammaRed;
	DWORD	bV4GammaGreen;
	DWORD	bV4GammaBlue;
} BITMAPV4HEADER,*LPBITMAPV4HEADER,*PBITMAPV4HEADER;
typedef struct { 
	DWORD	bV5Size; 
	LONG	bV5Width; 
	LONG	bV5Height; 
	WORD	bV5Planes; 
	WORD	bV5BitCount; 
	DWORD	bV5Compression; 
	DWORD	bV5SizeImage; 
	LONG	bV5XPelsPerMeter; 
	LONG	bV5YPelsPerMeter; 
	DWORD	bV5ClrUsed; 
	DWORD	bV5ClrImportant; 
	DWORD	bV5RedMask; 
	DWORD	bV5GreenMask; 
	DWORD	bV5BlueMask; 
	DWORD	bV5AlphaMask; 
	DWORD	bV5CSType; 
	CIEXYZTRIPLE bV5Endpoints; 
	DWORD	bV5GammaRed; 
	DWORD	bV5GammaGreen; 
	DWORD	bV5GammaBlue; 
	DWORD	bV5Intent; 
	DWORD	bV5ProfileData; 
	DWORD	bV5ProfileSize; 
	DWORD	bV5Reserved; 
} BITMAPV5HEADER,*LPBITMAPV5HEADER,*PBITMAPV5HEADER; 
typedef struct tagFONTSIGNATURE {
	DWORD	fsUsb[4];
	DWORD	fsCsb[2];
} FONTSIGNATURE,*LPFONTSIGNATURE;
typedef struct {
	UINT ciCharset;
	UINT ciACP;
	FONTSIGNATURE fs;
} CHARSETINFO,*LPCHARSETINFO;
typedef struct  tagCOLORADJUSTMENT {
	WORD	caSize;
	WORD	caFlags;
	WORD	caIlluminantIndex;
	WORD	caRedGamma;
	WORD	caGreenGamma;
	WORD	caBlueGamma;
	WORD	caReferenceBlack;
	WORD	caReferenceWhite;
	SHORT	caContrast;
	SHORT	caBrightness;
	SHORT	caColorfulness;
	SHORT	caRedGreenTint;
} COLORADJUSTMENT,*LPCOLORADJUSTMENT;
typedef struct _devicemodeA { 
  BYTE   dmDeviceName[CCHDEVICENAME]; 
  WORD   dmSpecVersion; 
  WORD   dmDriverVersion; 
  WORD   dmSize; 
  WORD   dmDriverExtra; 
  DWORD  dmFields; 
  _ANONYMOUS_UNION union {
    _ANONYMOUS_STRUCT struct {
      short dmOrientation;
      short dmPaperSize;
      short dmPaperLength;
      short dmPaperWidth;
      short dmScale; 
      short dmCopies; 
      short dmDefaultSource; 
      short dmPrintQuality; 
    } DUMMYSTRUCTNAME;
    POINTL dmPosition;
    DWORD  dmDisplayOrientation;
    DWORD  dmDisplayFixedOutput;
  } DUMMYUNIONNAME;

  short  dmColor; 
  short  dmDuplex; 
  short  dmYResolution; 
  short  dmTTOption; 
  short  dmCollate; 
  BYTE   dmFormName[CCHFORMNAME]; 
  WORD   dmLogPixels; 
  DWORD  dmBitsPerPel; 
  DWORD  dmPelsWidth; 
  DWORD  dmPelsHeight; 
  _ANONYMOUS_UNION union {
    DWORD  dmDisplayFlags; 
    DWORD  dmNup;
  } DUMMYUNIONNAME2;
  DWORD  dmDisplayFrequency; 
#if(WINVER >= 0x0400) 
  DWORD  dmICMMethod;
  DWORD  dmICMIntent;
  DWORD  dmMediaType;
  DWORD  dmDitherType;
  DWORD  dmReserved1;
  DWORD  dmReserved2;
#if (WINVER >= 0x0500) || (_WIN32_WINNT >= 0x0400)
  DWORD  dmPanningWidth;
  DWORD  dmPanningHeight;
#endif
#endif /* WINVER >= 0x0400 */
} DEVMODEA,*LPDEVMODEA,*PDEVMODEA;
typedef struct _devicemodeW { 
  WCHAR   dmDeviceName[CCHDEVICENAME]; 
  WORD   dmSpecVersion; 
  WORD   dmDriverVersion; 
  WORD   dmSize; 
  WORD   dmDriverExtra; 
  DWORD  dmFields; 
  _ANONYMOUS_UNION union {
    _ANONYMOUS_STRUCT struct {
      short dmOrientation;
      short dmPaperSize;
      short dmPaperLength;
      short dmPaperWidth;
      short dmScale; 
      short dmCopies; 
      short dmDefaultSource; 
      short dmPrintQuality; 
    } DUMMYSTRUCTNAME;
    POINTL dmPosition;
    DWORD  dmDisplayOrientation;
    DWORD  dmDisplayFixedOutput;
  } DUMMYUNIONNAME;

  short  dmColor; 
  short  dmDuplex; 
  short  dmYResolution; 
  short  dmTTOption; 
  short  dmCollate; 
  WCHAR  dmFormName[CCHFORMNAME]; 
  WORD   dmLogPixels; 
  DWORD  dmBitsPerPel; 
  DWORD  dmPelsWidth; 
  DWORD  dmPelsHeight; 
  _ANONYMOUS_UNION union {
    DWORD  dmDisplayFlags; 
    DWORD  dmNup;
  } DUMMYUNIONNAME2;
  DWORD  dmDisplayFrequency; 
#if(WINVER >= 0x0400) 
  DWORD  dmICMMethod;
  DWORD  dmICMIntent;
  DWORD  dmMediaType;
  DWORD  dmDitherType;
  DWORD  dmReserved1;
  DWORD  dmReserved2;
#if (WINVER >= 0x0500) || (_WIN32_WINNT >= 0x0400)
  DWORD  dmPanningWidth;
  DWORD  dmPanningHeight;
#endif
#endif /* WINVER >= 0x0400 */
} DEVMODEW,*LPDEVMODEW,*PDEVMODEW;
typedef struct tagDIBSECTION {
	BITMAP dsBm;
	BITMAPINFOHEADER dsBmih;
	DWORD dsBitfields[3];
	HANDLE dshSection;
	DWORD dsOffset;
} DIBSECTION;
typedef struct _DOCINFOA {
	int cbSize;
	LPCSTR lpszDocName;
	LPCSTR lpszOutput;
	LPCSTR lpszDatatype;
	DWORD fwType;
} DOCINFOA,*LPDOCINFOA;
typedef struct _DOCINFOW {
	int cbSize;
	LPCWSTR lpszDocName;
	LPCWSTR lpszOutput;
	LPCWSTR lpszDatatype;
	DWORD fwType;
} DOCINFOW,*LPDOCINFOW;
typedef struct tagEMR {
	DWORD iType;
	DWORD nSize;
} EMR,*PEMR;
typedef struct tagEMRANGLEARC {
	EMR emr;
	POINTL ptlCenter;
	DWORD nRadius;
	FLOAT eStartAngle;
	FLOAT eSweepAngle;
} EMRANGLEARC,*PEMRANGLEARC;
typedef struct tagEMRARC {
	EMR emr;
	RECTL rclBox;
	POINTL ptlStart;
	POINTL ptlEnd;
} EMRARC,*PEMRARC,EMRARCTO,*PEMRARCTO,EMRCHORD,*PEMRCHORD,EMRPIE,*PEMRPIE;
typedef struct  _XFORM {
	FLOAT eM11;
	FLOAT eM12;
	FLOAT eM21;
	FLOAT eM22;
	FLOAT eDx;
	FLOAT eDy;
} XFORM,*PXFORM,*LPXFORM;
typedef struct tagEMRBITBLT {
	EMR emr;
	RECTL rclBounds;
	LONG xDest;
	LONG yDest;
	LONG cxDest;
	LONG cyDest;
	DWORD dwRop;
	LONG xSrc;
	LONG ySrc;
	XFORM xformSrc;
	COLORREF crBkColorSrc;
	DWORD iUsageSrc;
	DWORD offBmiSrc;
	DWORD offBitsSrc;
	DWORD cbBitsSrc;
} EMRBITBLT,*PEMRBITBLT;
typedef struct tagLOGBRUSH {
	UINT lbStyle;
	COLORREF lbColor;
	LONG lbHatch;
} LOGBRUSH,*PLOGBRUSH,*LPLOGBRUSH;
typedef LOGBRUSH PATTERN,*PPATTERN,*LPPATTERN;
typedef struct tagEMRCREATEBRUSHINDIRECT {
	EMR emr;
	DWORD ihBrush;
	LOGBRUSH lb;
} EMRCREATEBRUSHINDIRECT,*PEMRCREATEBRUSHINDIRECT;
typedef LONG LCSCSTYPE;
typedef LONG LCSGAMUTMATCH;
typedef struct tagLOGCOLORSPACEA {
	DWORD lcsSignature;
	DWORD lcsVersion;
	DWORD lcsSize;
	LCSCSTYPE lcsCSType;
	LCSGAMUTMATCH lcsIntent;
	CIEXYZTRIPLE lcsEndpoints;
	DWORD lcsGammaRed;
	DWORD lcsGammaGreen;
	DWORD lcsGammaBlue;
	CHAR lcsFilename[MAX_PATH];
} LOGCOLORSPACEA,*LPLOGCOLORSPACEA;
typedef struct tagLOGCOLORSPACEW {
	DWORD lcsSignature;
	DWORD lcsVersion;
	DWORD lcsSize;
	LCSCSTYPE lcsCSType;
	LCSGAMUTMATCH lcsIntent;
	CIEXYZTRIPLE lcsEndpoints;
	DWORD lcsGammaRed;
	DWORD lcsGammaGreen;
	DWORD lcsGammaBlue;
	WCHAR lcsFilename[MAX_PATH];
} LOGCOLORSPACEW,*LPLOGCOLORSPACEW;
typedef struct tagEMRCREATECOLORSPACE {
	EMR emr;
	DWORD ihCS;
	LOGCOLORSPACEW lcs;
} EMRCREATECOLORSPACE,*PEMRCREATECOLORSPACE;
typedef struct tagEMRCREATEDIBPATTERNBRUSHPT {
	EMR emr;
	DWORD ihBrush;
	DWORD iUsage;
	DWORD offBmi;
	DWORD cbBmi;
	DWORD offBits;
	DWORD cbBits;
} EMRCREATEDIBPATTERNBRUSHPT,*PEMRCREATEDIBPATTERNBRUSHPT;
typedef struct tagEMRCREATEMONOBRUSH {
	EMR emr;
	DWORD ihBrush;
	DWORD iUsage;
	DWORD offBmi;
	DWORD cbBmi;
	DWORD offBits;
	DWORD cbBits;
} EMRCREATEMONOBRUSH,*PEMRCREATEMONOBRUSH;
typedef struct tagPALETTEENTRY {
	BYTE peRed;
	BYTE peGreen;
	BYTE peBlue;
	BYTE peFlags;
} PALETTEENTRY,*LPPALETTEENTRY,*PPALETTEENTRY;
typedef struct tagLOGPALETTE {
	WORD palVersion;
	WORD palNumEntries;
	PALETTEENTRY palPalEntry[1];
} LOGPALETTE,*NPLOGPALETTE,*PLOGPALETTE,*LPLOGPALETTE;
typedef struct tagEMRCREATEPALETTE {
	EMR emr;
	DWORD ihPal;
	LOGPALETTE lgpl;
} EMRCREATEPALETTE,*PEMRCREATEPALETTE;
typedef struct tagLOGPEN {
	UINT lopnStyle;
	POINT lopnWidth;
	COLORREF lopnColor;
} LOGPEN,*PLOGPEN,*LPLOGPEN;
typedef struct tagEMRCREATEPEN {
	EMR emr;
	DWORD ihPen;
	LOGPEN lopn;
} EMRCREATEPEN,*PEMRCREATEPEN;
typedef struct tagEMRELLIPSE {
	EMR emr;
	RECTL rclBox;
} EMRELLIPSE,*PEMRELLIPSE,EMRRECTANGLE,*PEMRRECTANGLE;
typedef struct tagEMREOF {
	EMR emr;
	DWORD nPalEntries;
	DWORD offPalEntries;
	DWORD nSizeLast;
} EMREOF,*PEMREOF;
typedef struct tagEMREXCLUDECLIPRECT {
	EMR emr;
	RECTL rclClip;
} EMREXCLUDECLIPRECT,*PEMREXCLUDECLIPRECT,EMRINTERSECTCLIPRECT,*PEMRINTERSECTCLIPRECT;
typedef struct tagPANOSE {
	BYTE bFamilyType;
	BYTE bSerifStyle;
	BYTE bWeight;
	BYTE bProportion;
	BYTE bContrast;
	BYTE bStrokeVariation;
	BYTE bArmStyle;
	BYTE bLetterform;
	BYTE bMidline;
	BYTE bXHeight;
} PANOSE;
typedef struct tagLOGFONTA {
	LONG	lfHeight;
	LONG	lfWidth;
	LONG	lfEscapement;
	LONG	lfOrientation;
	LONG	lfWeight;
	BYTE	lfItalic;
	BYTE	lfUnderline;
	BYTE	lfStrikeOut;
	BYTE	lfCharSet;
	BYTE	lfOutPrecision;
	BYTE	lfClipPrecision;
	BYTE	lfQuality;
	BYTE	lfPitchAndFamily;
	CHAR	lfFaceName[LF_FACESIZE];
} LOGFONTA,*PLOGFONTA,*LPLOGFONTA;
typedef struct tagLOGFONTW {
	LONG	lfHeight;
	LONG	lfWidth;
	LONG	lfEscapement;
	LONG	lfOrientation;
	LONG	lfWeight;
	BYTE	lfItalic;
	BYTE	lfUnderline;
	BYTE	lfStrikeOut;
	BYTE	lfCharSet;
	BYTE	lfOutPrecision;
	BYTE	lfClipPrecision;
	BYTE	lfQuality;
	BYTE	lfPitchAndFamily;
	WCHAR	lfFaceName[LF_FACESIZE];
} LOGFONTW,*PLOGFONTW,*LPLOGFONTW;
typedef struct tagEXTLOGFONTA {
	LOGFONTA	elfLogFont;
	BYTE	elfFullName[LF_FULLFACESIZE];
	BYTE	elfStyle[LF_FACESIZE];
	DWORD	elfVersion;
	DWORD	elfStyleSize;
	DWORD	elfMatch;
	DWORD	elfReserved;
	BYTE	elfVendorId[ELF_VENDOR_SIZE];
	DWORD	elfCulture;
	PANOSE	elfPanose;
} EXTLOGFONTA,*PEXTLOGFONTA,*LPEXTLOGFONTA;
typedef struct tagEXTLOGFONTW {
	LOGFONTW	elfLogFont;
	WCHAR	elfFullName[LF_FULLFACESIZE];
	WCHAR	elfStyle[LF_FACESIZE];
	DWORD	elfVersion;
	DWORD	elfStyleSize;
	DWORD	elfMatch;
	DWORD	elfReserved;
	BYTE	elfVendorId[ELF_VENDOR_SIZE];
	DWORD	elfCulture;
	PANOSE	elfPanose;
} EXTLOGFONTW,*PEXTLOGFONTW,*LPEXTLOGFONTW;
typedef struct tagEMREXTCREATEFONTINDIRECTW {
	EMR emr;
	DWORD ihFont;
	EXTLOGFONTW elfw;
} EMREXTCREATEFONTINDIRECTW,*PEMREXTCREATEFONTINDIRECTW;
typedef struct tagEXTLOGPEN {
	UINT elpPenStyle;
	UINT elpWidth;
	UINT elpBrushStyle;
	COLORREF elpColor;
	LONG elpHatch;
	DWORD elpNumEntries;
	DWORD elpStyleEntry[1];
} EXTLOGPEN,*PEXTLOGPEN,*LPEXTLOGPEN;
typedef struct tagEMREXTCREATEPEN {
	EMR emr;
	DWORD ihPen;
	DWORD offBmi;
	DWORD cbBmi;
	DWORD offBits;
	DWORD cbBits;
	EXTLOGPEN elp;
} EMREXTCREATEPEN,*PEMREXTCREATEPEN;
typedef struct tagEMREXTFLOODFILL {
	EMR emr;
	POINTL ptlStart;
	COLORREF crColor;
	DWORD iMode;
} EMREXTFLOODFILL,*PEMREXTFLOODFILL;
typedef struct tagEMREXTSELECTCLIPRGN {
	EMR emr;
	DWORD cbRgnData;
	DWORD iMode;
	BYTE RgnData[1];
} EMREXTSELECTCLIPRGN,*PEMREXTSELECTCLIPRGN;
typedef struct tagEMRTEXT {
	POINTL ptlReference;
	DWORD nChars;
	DWORD offString;
	DWORD fOptions;
	RECTL rcl;
	DWORD offDx;
} EMRTEXT,*PEMRTEXT;
typedef struct tagEMREXTTEXTOUTA {
	EMR emr;
	RECTL rclBounds;
	DWORD iGraphicsMode;
	FLOAT exScale;
	FLOAT eyScale;
	EMRTEXT emrtext;
} EMREXTTEXTOUTA,*PEMREXTTEXTOUTA,EMREXTTEXTOUTW,*PEMREXTTEXTOUTW;
typedef struct tagEMRFILLPATH {
	EMR emr;
	RECTL rclBounds;
} EMRFILLPATH,*PEMRFILLPATH,EMRSTROKEANDFILLPATH,*PEMRSTROKEANDFILLPATH,EMRSTROKEPATH,*PEMRSTROKEPATH;
typedef struct tagEMRFILLRGN {
	EMR emr;
	RECTL rclBounds;
	DWORD cbRgnData;
	DWORD ihBrush;
	BYTE RgnData[1];
} EMRFILLRGN,*PEMRFILLRGN;
typedef struct tagEMRFORMAT   {
	DWORD dSignature;
	DWORD nVersion;
	DWORD cbData;
	DWORD offData;
} EMRFORMAT;
typedef struct tagEMRFRAMERGN {
	EMR emr;
	RECTL rclBounds;
	DWORD cbRgnData;
	DWORD ihBrush;
	SIZEL szlStroke;
	BYTE RgnData[1];
} EMRFRAMERGN,*PEMRFRAMERGN;
typedef struct tagEMRGDICOMMENT {
	EMR emr;
	DWORD cbData;
	BYTE Data[1];
} EMRGDICOMMENT,*PEMRGDICOMMENT;
typedef struct tagEMRINVERTRGN {
	EMR emr;
	RECTL rclBounds;
	DWORD cbRgnData;
	BYTE RgnData[1];
} EMRINVERTRGN,*PEMRINVERTRGN,EMRPAINTRGN,*PEMRPAINTRGN;
typedef struct tagEMRLINETO {
	EMR emr;
	POINTL ptl;
} EMRLINETO,*PEMRLINETO,EMRMOVETOEX,*PEMRMOVETOEX;
typedef struct tagEMRMASKBLT {
	EMR emr;
	RECTL rclBounds;
	LONG xDest;
	LONG yDest;
	LONG cxDest;
	LONG cyDest;
	DWORD dwRop;
	LONG xSrc;
	LONG ySrc;
	XFORM xformSrc;
	COLORREF crBkColorSrc;
	DWORD iUsageSrc;
	DWORD offBmiSrc;
	DWORD cbBmiSrc;
	DWORD offBitsSrc;
	DWORD cbBitsSrc;
	LONG xMask;
	LONG yMask;
	DWORD iUsageMask;
	DWORD offBmiMask;
	DWORD cbBmiMask;
	DWORD offBitsMask;
	DWORD cbBitsMask;
} EMRMASKBLT,*PEMRMASKBLT;
typedef struct tagEMRMODIFYWORLDTRANSFORM {
	EMR emr;
	XFORM xform;
	DWORD iMode;
} EMRMODIFYWORLDTRANSFORM,*PEMRMODIFYWORLDTRANSFORM;
typedef struct tagEMROFFSETCLIPRGN {
	EMR emr;
	POINTL ptlOffset;
} EMROFFSETCLIPRGN,*PEMROFFSETCLIPRGN;
typedef struct tagEMRPLGBLT {
	EMR emr;
	RECTL rclBounds;
	POINTL aptlDest[3];
	LONG xSrc;
	LONG ySrc;
	LONG cxSrc;
	LONG cySrc;
	XFORM xformSrc;
	COLORREF crBkColorSrc;
	DWORD iUsageSrc;
	DWORD offBmiSrc;
	DWORD cbBmiSrc;
	DWORD offBitsSrc;
	DWORD cbBitsSrc;
	LONG xMask;
	LONG yMask;
	DWORD iUsageMask;
	DWORD offBmiMask;
	DWORD cbBmiMask;
	DWORD offBitsMask;
	DWORD cbBitsMask;
} EMRPLGBLT,*PEMRPLGBLT;
typedef struct tagEMRPOLYDRAW {
	EMR emr;
	RECTL rclBounds;
	DWORD cptl;
	POINTL aptl[1];
	BYTE abTypes[1];
} EMRPOLYDRAW,*PEMRPOLYDRAW;
typedef struct tagEMRPOLYDRAW16 {
	EMR emr;
	RECTL rclBounds;
	DWORD cpts;
	POINTS apts[1];
	BYTE abTypes[1];
} EMRPOLYDRAW16,*PEMRPOLYDRAW16;
typedef struct tagEMRPOLYLINE {
	EMR emr;
	RECTL rclBounds;
	DWORD cptl;
	POINTL aptl[1];
} EMRPOLYLINE,*PEMRPOLYLINE,EMRPOLYBEZIER,*PEMRPOLYBEZIER,EMRPOLYGON,*PEMRPOLYGON,EMRPOLYBEZIERTO,*PEMRPOLYBEZIERTO,EMRPOLYLINETO,*PEMRPOLYLINETO;
typedef struct tagEMRPOLYLINE16 {
	EMR emr;
	RECTL rclBounds;
	DWORD cpts;
	POINTL apts[1];
} EMRPOLYLINE16,*PEMRPOLYLINE16,EMRPOLYBEZIER16,*PEMRPOLYBEZIER16,EMRPOLYGON16,*PEMRPOLYGON16,EMRPOLYBEZIERTO16,*PEMRPOLYBEZIERTO16,EMRPOLYLINETO16,*PEMRPOLYLINETO16;
typedef struct tagEMRPOLYPOLYLINE {
	EMR emr;
	RECTL rclBounds;
	DWORD nPolys;
	DWORD cptl;
	DWORD aPolyCounts[1];
	POINTL aptl[1];
} EMRPOLYPOLYLINE,*PEMRPOLYPOLYLINE,EMRPOLYPOLYGON,*PEMRPOLYPOLYGON;
typedef struct tagEMRPOLYPOLYLINE16 {
	EMR emr;
	RECTL rclBounds;
	DWORD nPolys;
	DWORD cpts;
	DWORD aPolyCounts[1];
	POINTS apts[1];
} EMRPOLYPOLYLINE16,*PEMRPOLYPOLYLINE16,EMRPOLYPOLYGON16,*PEMRPOLYPOLYGON16;
typedef struct tagEMRPOLYTEXTOUTA {
	EMR emr;
	RECTL rclBounds;
	DWORD iGraphicsMode;
	FLOAT exScale;
	FLOAT eyScale;
	LONG cStrings;
	EMRTEXT aemrtext[1];
} EMRPOLYTEXTOUTA,*PEMRPOLYTEXTOUTA,EMRPOLYTEXTOUTW,*PEMRPOLYTEXTOUTW;
typedef struct tagEMRRESIZEPALETTE {
	EMR emr;
	DWORD ihPal;
	DWORD cEntries;
} EMRRESIZEPALETTE,*PEMRRESIZEPALETTE;
typedef struct tagEMRRESTOREDC {
	EMR emr;
	LONG iRelative;
} EMRRESTOREDC,*PEMRRESTOREDC;
typedef struct tagEMRROUNDRECT {
	EMR emr;
	RECTL rclBox;
	SIZEL szlCorner;
} EMRROUNDRECT,*PEMRROUNDRECT;
typedef struct tagEMRSCALEVIEWPORTEXTEX {
	EMR emr;
	LONG xNum;
	LONG xDenom;
	LONG yNum;
	LONG yDenom;
} EMRSCALEVIEWPORTEXTEX,*PEMRSCALEVIEWPORTEXTEX,EMRSCALEWINDOWEXTEX,*PEMRSCALEWINDOWEXTEX;
typedef struct tagEMRSELECTCOLORSPACE {
	EMR emr;
	DWORD ihCS;
} EMRSELECTCOLORSPACE,*PEMRSELECTCOLORSPACE,EMRDELETECOLORSPACE,*PEMRDELETECOLORSPACE;
typedef struct tagEMRSELECTOBJECT {
	EMR emr;
	DWORD ihObject;
} EMRSELECTOBJECT,*PEMRSELECTOBJECT,EMRDELETEOBJECT,*PEMRDELETEOBJECT;
typedef struct tagEMRSELECTPALETTE {
	EMR emr;
	DWORD ihPal;
} EMRSELECTPALETTE,*PEMRSELECTPALETTE;
typedef struct tagEMRSETARCDIRECTION {
	EMR emr;
	DWORD iArcDirection;
} EMRSETARCDIRECTION,*PEMRSETARCDIRECTION;
typedef struct tagEMRSETTEXTCOLOR {
	EMR emr;
	COLORREF crColor;
} EMRSETBKCOLOR,*PEMRSETBKCOLOR,EMRSETTEXTCOLOR,*PEMRSETTEXTCOLOR;
typedef struct tagEMRSETCOLORADJUSTMENT {
	EMR emr;
	COLORADJUSTMENT ColorAdjustment;
} EMRSETCOLORADJUSTMENT,*PEMRSETCOLORADJUSTMENT;
typedef struct tagEMRSETDIBITSTODEVICE {
	EMR emr;
	RECTL rclBounds;
	LONG xDest;
	LONG yDest;
	LONG xSrc;
	LONG ySrc;
	LONG cxSrc;
	LONG cySrc;
	DWORD offBmiSrc;
	DWORD cbBmiSrc;
	DWORD offBitsSrc;
	DWORD cbBitsSrc;
	DWORD iUsageSrc;
	DWORD iStartScan;
	DWORD cScans;
} EMRSETDIBITSTODEVICE,*PEMRSETDIBITSTODEVICE;
typedef struct tagEMRSETMAPPERFLAGS {
	EMR emr;
	DWORD dwFlags;
} EMRSETMAPPERFLAGS,*PEMRSETMAPPERFLAGS;
typedef struct tagEMRSETMITERLIMIT {
	EMR emr;
	FLOAT eMiterLimit;
} EMRSETMITERLIMIT,*PEMRSETMITERLIMIT;
typedef struct tagEMRSETPALETTEENTRIES {
	EMR emr;
	DWORD ihPal;
	DWORD iStart;
	DWORD cEntries;
	PALETTEENTRY aPalEntries[1];
} EMRSETPALETTEENTRIES,*PEMRSETPALETTEENTRIES;
typedef struct tagEMRSETPIXELV {
	EMR emr;
	POINTL ptlPixel;
	COLORREF crColor;
} EMRSETPIXELV,*PEMRSETPIXELV;
typedef struct tagEMRSETVIEWPORTEXTEX {
	EMR emr;
	SIZEL szlExtent;
} EMRSETVIEWPORTEXTEX,*PEMRSETVIEWPORTEXTEX,EMRSETWINDOWEXTEX,*PEMRSETWINDOWEXTEX;
typedef struct tagEMRSETVIEWPORTORGEX {
	EMR emr;
	POINTL ptlOrigin;
} EMRSETVIEWPORTORGEX,*PEMRSETVIEWPORTORGEX,EMRSETWINDOWORGEX,*PEMRSETWINDOWORGEX,EMRSETBRUSHORGEX,*PEMRSETBRUSHORGEX;
typedef struct tagEMRSETWORLDTRANSFORM {
	EMR emr;
	XFORM xform;
} EMRSETWORLDTRANSFORM,*PEMRSETWORLDTRANSFORM;
typedef struct tagEMRSTRETCHBLT {
	EMR emr;
	RECTL rclBounds;
	LONG xDest;
	LONG yDest;
	LONG cxDest;
	LONG cyDest;
	DWORD dwRop;
	LONG xSrc;
	LONG ySrc;
	XFORM xformSrc;
	COLORREF crBkColorSrc;
	DWORD iUsageSrc;
	DWORD offBmiSrc;
	DWORD cbBmiSrc;
	DWORD offBitsSrc;
	DWORD cbBitsSrc;
	LONG cxSrc;
	LONG cySrc;
} EMRSTRETCHBLT,*PEMRSTRETCHBLT;
typedef struct tagEMRSTRETCHDIBITS {
	EMR emr;
	RECTL rclBounds;
	LONG xDest;
	LONG yDest;
	LONG xSrc;
	LONG ySrc;
	LONG cxSrc;
	LONG cySrc;
	DWORD offBmiSrc;
	DWORD cbBmiSrc;
	DWORD offBitsSrc;
	DWORD cbBitsSrc;
	DWORD iUsageSrc;
	DWORD dwRop;
	LONG cxDest;
	LONG cyDest;
} EMRSTRETCHDIBITS,*PEMRSTRETCHDIBITS;
typedef struct tagABORTPATH {
	EMR emr;
} EMRABORTPATH,*PEMRABORTPATH,EMRBEGINPATH,*PEMRBEGINPATH,EMRENDPATH,*PEMRENDPATH,EMRCLOSEFIGURE,*PEMRCLOSEFIGURE,EMRFLATTENPATH,*PEMRFLATTENPATH,EMRWIDENPATH,*PEMRWIDENPATH,EMRSETMETARGN,*PEMRSETMETARGN,EMRSAVEDC,*PEMRSAVEDC,EMRREALIZEPALETTE,*PEMRREALIZEPALETTE;
typedef struct tagEMRSELECTCLIPPATH {
	EMR emr;
	DWORD iMode;
} EMRSELECTCLIPPATH,*PEMRSELECTCLIPPATH,EMRSETBKMODE,*PEMRSETBKMODE,EMRSETMAPMODE,*PEMRSETMAPMODE,EMRSETPOLYFILLMODE,*PEMRSETPOLYFILLMODE,EMRSETROP2,*PEMRSETROP2,EMRSETSTRETCHBLTMODE,*PEMRSETSTRETCHBLTMODE,EMRSETTEXTALIGN,*PEMRSETTEXTALIGN,EMRENABLEICM,*PEMRENABLEICM;
#pragma pack(push,2)
typedef struct tagMETAHEADER {
	WORD mtType;
	WORD mtHeaderSize;
	WORD mtVersion;
	DWORD mtSize;
	WORD mtNoObjects;
	DWORD mtMaxRecord;
	WORD mtNoParameters;
} METAHEADER,*PMETAHEADER,*LPMETAHEADER;
#pragma pack(pop)
typedef struct tagENHMETAHEADER {
	DWORD iType;
	DWORD nSize;
	RECTL rclBounds;
	RECTL rclFrame;
	DWORD dSignature;
	DWORD nVersion;
	DWORD nBytes;
	DWORD nRecords;
	WORD nHandles;
	WORD sReserved;
	DWORD nDescription;
	DWORD offDescription;
	DWORD nPalEntries;
	SIZEL szlDevice;
	SIZEL szlMillimeters;
#if (WINVER >= 0x0400)
	DWORD cbPixelFormat;
	DWORD offPixelFormat;
	DWORD bOpenGL;
#endif
#if (WINVER >= 0x0500)
	SIZEL szlMicrometers;
#endif
} ENHMETAHEADER,*LPENHMETAHEADER;
typedef struct tagMETARECORD {
	DWORD rdSize;
	WORD rdFunction;
	WORD rdParm[1];
} METARECORD,*PMETARECORD,*LPMETARECORD;
typedef struct tagENHMETARECORD {
	DWORD iType;
	DWORD nSize;
	DWORD dParm[1];
} ENHMETARECORD,*LPENHMETARECORD;
typedef struct tagHANDLETABLE {
	HGDIOBJ objectHandle[1];
} HANDLETABLE,*LPHANDLETABLE;
typedef struct tagTEXTMETRICA {
	LONG tmHeight;
	LONG tmAscent;
	LONG tmDescent;
	LONG tmInternalLeading;
	LONG tmExternalLeading;
	LONG tmAveCharWidth;
	LONG tmMaxCharWidth;
	LONG tmWeight;
	LONG tmOverhang;
	LONG tmDigitizedAspectX;
	LONG tmDigitizedAspectY;
	BYTE tmFirstChar;
	BYTE tmLastChar;
	BYTE tmDefaultChar;
	BYTE tmBreakChar;
	BYTE tmItalic;
	BYTE tmUnderlined;
	BYTE tmStruckOut;
	BYTE tmPitchAndFamily;
	BYTE tmCharSet;
} TEXTMETRICA,*PTEXTMETRICA,*LPTEXTMETRICA;
typedef struct tagTEXTMETRICW {
	LONG tmHeight;
	LONG tmAscent;
	LONG tmDescent;
	LONG tmInternalLeading;
	LONG tmExternalLeading;
	LONG tmAveCharWidth;
	LONG tmMaxCharWidth;
	LONG tmWeight;
	LONG tmOverhang;
	LONG tmDigitizedAspectX;
	LONG tmDigitizedAspectY;
	WCHAR tmFirstChar;
	WCHAR tmLastChar;
	WCHAR tmDefaultChar;
	WCHAR tmBreakChar;
	BYTE tmItalic;
	BYTE tmUnderlined;
	BYTE tmStruckOut;
	BYTE tmPitchAndFamily;
	BYTE tmCharSet;
} TEXTMETRICW,*PTEXTMETRICW,*LPTEXTMETRICW;
typedef struct _RGNDATAHEADER {
	DWORD dwSize;
	DWORD iType;
	DWORD nCount;
	DWORD nRgnSize;
	RECT rcBound;
} RGNDATAHEADER;
typedef struct _RGNDATA {
	RGNDATAHEADER rdh;
	char Buffer[1];
} RGNDATA,*PRGNDATA, *LPRGNDATA;
/* for GetRandomRgn */
#define SYSRGN  4
typedef struct tagGCP_RESULTSA {
	DWORD lStructSize;
	LPSTR lpOutString;
	UINT *lpOrder;
	INT *lpDx;
	INT *lpCaretPos;
	LPSTR lpClass;
	LPWSTR lpGlyphs;
	UINT nGlyphs;
	UINT nMaxFit;
} GCP_RESULTSA,*LPGCP_RESULTSA;
typedef struct tagGCP_RESULTSW {
	DWORD lStructSize;
	LPWSTR lpOutString;
	UINT *lpOrder;
	INT *lpDx;
	INT *lpCaretPos;
	LPWSTR lpClass;
	LPWSTR lpGlyphs;
	UINT nGlyphs;
	UINT nMaxFit;
} GCP_RESULTSW,*LPGCP_RESULTSW;
typedef struct _GLYPHMETRICS {
	UINT gmBlackBoxX;
	UINT gmBlackBoxY;
	POINT gmptGlyphOrigin;
	short gmCellIncX;
	short gmCellIncY;
} GLYPHMETRICS,*LPGLYPHMETRICS;
#if (_WIN32_WINNT >= 0x0500)
typedef struct tagWCRANGE
{
	WCHAR wcLow;
	USHORT cGlyphs;
} WCRANGE, *PWCRANGE, *LPWCRANGE;
typedef struct tagGLYPHSET
{
	DWORD cbThis;
	DWORD flAccel;
	DWORD cGlyphsSupported;
	DWORD cRanges;
	WCRANGE ranges[1];
} GLYPHSET, *PGLYPHSET, *LPGLYPHSET;
#endif
typedef struct tagKERNINGPAIR {
	WORD wFirst;
	WORD wSecond;
	int iKernAmount;
} KERNINGPAIR,*LPKERNINGPAIR;
typedef struct _FIXED {
	WORD fract;
	short value;
} FIXED;
typedef struct _MAT2 {
	FIXED eM11;
	FIXED eM12;
	FIXED eM21;
	FIXED eM22;
} MAT2,*LPMAT2;
typedef struct _OUTLINETEXTMETRICA {
	UINT otmSize;
	TEXTMETRICA otmTextMetrics;
	BYTE otmFiller;
	PANOSE otmPanoseNumber;
	UINT otmfsSelection;
	UINT otmfsType;
	int otmsCharSlopeRise;
	int otmsCharSlopeRun;
	int otmItalicAngle;
	UINT otmEMSquare;
	int otmAscent;
	int otmDescent;
	UINT otmLineGap;
	UINT otmsCapEmHeight;
	UINT otmsXHeight;
	RECT otmrcFontBox;
	int otmMacAscent;
	int otmMacDescent;
	UINT otmMacLineGap;
	UINT otmusMinimumPPEM;
	POINT otmptSubscriptSize;
	POINT otmptSubscriptOffset;
	POINT otmptSuperscriptSize;
	POINT otmptSuperscriptOffset;
	UINT otmsStrikeoutSize;
	int otmsStrikeoutPosition;
	int otmsUnderscoreSize;
	int otmsUnderscorePosition;
	PSTR otmpFamilyName;
	PSTR otmpFaceName;
	PSTR otmpStyleName;
	PSTR otmpFullName;
} OUTLINETEXTMETRICA,*POUTLINETEXTMETRICA,*LPOUTLINETEXTMETRICA;
typedef struct _OUTLINETEXTMETRICW {
	UINT otmSize;
	TEXTMETRICW otmTextMetrics;
	BYTE otmFiller;
	PANOSE otmPanoseNumber;
	UINT otmfsSelection;
	UINT otmfsType;
	int otmsCharSlopeRise;
	int otmsCharSlopeRun;
	int otmItalicAngle;
	UINT otmEMSquare;
	int otmAscent;
	int otmDescent;
	UINT otmLineGap;
	UINT otmsCapEmHeight;
	UINT otmsXHeight;
	RECT otmrcFontBox;
	int otmMacAscent;
	int otmMacDescent;
	UINT otmMacLineGap;
	UINT otmusMinimumPPEM;
	POINT otmptSubscriptSize;
	POINT otmptSubscriptOffset;
	POINT otmptSuperscriptSize;
	POINT otmptSuperscriptOffset;
	UINT otmsStrikeoutSize;
	int otmsStrikeoutPosition;
	int otmsUnderscoreSize;
	int otmsUnderscorePosition;
	PSTR otmpFamilyName;
	PSTR otmpFaceName;
	PSTR otmpStyleName;
	PSTR otmpFullName;
} OUTLINETEXTMETRICW,*POUTLINETEXTMETRICW,*LPOUTLINETEXTMETRICW;
typedef struct _RASTERIZER_STATUS {
	short nSize;
	short wFlags;
	short nLanguageID;
} RASTERIZER_STATUS,*LPRASTERIZER_STATUS;
typedef struct _POLYTEXTA {
	int x;
	int y;
	UINT n;
	LPCSTR lpstr;
	UINT uiFlags;
	RECT rcl;
	int *pdx;
} POLYTEXTA, *PPOLYTEXTA, *LPPOLYTEXTA;
typedef struct _POLYTEXTW {
	int x;
	int y;
	UINT n;
	LPCWSTR lpstr;
	UINT uiFlags;
	RECT rcl;
	int *pdx;
} POLYTEXTW, *PPOLYTEXTW, *LPPOLYTEXTW;
typedef struct tagPIXELFORMATDESCRIPTOR {
	WORD nSize;
	WORD nVersion;
	DWORD dwFlags;
	BYTE iPixelType;
	BYTE cColorBits;
	BYTE cRedBits;
	BYTE cRedShift;
	BYTE cGreenBits;
	BYTE cGreenShift;
	BYTE cBlueBits;
	BYTE cBlueShift;
	BYTE cAlphaBits;
	BYTE cAlphaShift;
	BYTE cAccumBits;
	BYTE cAccumRedBits;
	BYTE cAccumGreenBits;
	BYTE cAccumBlueBits;
	BYTE cAccumAlphaBits;
	BYTE cDepthBits;
	BYTE cStencilBits;
	BYTE cAuxBuffers;
	BYTE iLayerType;
	BYTE bReserved;
	DWORD dwLayerMask;
	DWORD dwVisibleMask;
	DWORD dwDamageMask;
} PIXELFORMATDESCRIPTOR,*PPIXELFORMATDESCRIPTOR,*LPPIXELFORMATDESCRIPTOR;
typedef struct tagMETAFILEPICT {
	LONG mm;
	LONG xExt;
	LONG yExt;
	HMETAFILE hMF;
} METAFILEPICT,*LPMETAFILEPICT;
typedef struct tagLOCALESIGNATURE {
	DWORD lsUsb[4];
	DWORD lsCsbDefault[2];
	DWORD lsCsbSupported[2];
} LOCALESIGNATURE,*PLOCALESIGNATURE,*LPLOCALESIGNATURE;
typedef LONG LCSTYPE;
#pragma pack(push,4)
typedef struct tagNEWTEXTMETRICA {
	LONG tmHeight;
	LONG tmAscent;
	LONG tmDescent;
	LONG tmInternalLeading;
	LONG tmExternalLeading;
	LONG tmAveCharWidth;
	LONG tmMaxCharWidth;
	LONG tmWeight;
	LONG tmOverhang;
	LONG tmDigitizedAspectX;
	LONG tmDigitizedAspectY;
	BYTE tmFirstChar;
	BYTE tmLastChar;
	BYTE tmDefaultChar;
	BYTE tmBreakChar;
	BYTE tmItalic;
	BYTE tmUnderlined;
	BYTE tmStruckOut;
	BYTE tmPitchAndFamily;
	BYTE tmCharSet;
	DWORD ntmFlags;
	UINT ntmSizeEM;
	UINT ntmCellHeight;
	UINT ntmAvgWidth;
} NEWTEXTMETRICA,*PNEWTEXTMETRICA,*LPNEWTEXTMETRICA;
typedef struct tagNEWTEXTMETRICW {
	LONG tmHeight;
	LONG tmAscent;
	LONG tmDescent;
	LONG tmInternalLeading;
	LONG tmExternalLeading;
	LONG tmAveCharWidth;
	LONG tmMaxCharWidth;
	LONG tmWeight;
	LONG tmOverhang;
	LONG tmDigitizedAspectX;
	LONG tmDigitizedAspectY;
	WCHAR tmFirstChar;
	WCHAR tmLastChar;
	WCHAR tmDefaultChar;
	WCHAR tmBreakChar;
	BYTE tmItalic;
	BYTE tmUnderlined;
	BYTE tmStruckOut;
	BYTE tmPitchAndFamily;
	BYTE tmCharSet;
	DWORD ntmFlags;
	UINT ntmSizeEM;
	UINT ntmCellHeight;
	UINT ntmAvgWidth;
} NEWTEXTMETRICW,*PNEWTEXTMETRICW,*LPNEWTEXTMETRICW;
#pragma pack(pop)
typedef struct tagNEWTEXTMETRICEXA {
	NEWTEXTMETRICA ntmTm;
	FONTSIGNATURE ntmFontSig;
} NEWTEXTMETRICEXA;
typedef struct tagNEWTEXTMETRICEXW {
	NEWTEXTMETRICW ntmTm;
	FONTSIGNATURE ntmFontSig;
} NEWTEXTMETRICEXW;
typedef struct tagPELARRAY {
	LONG paXCount;
	LONG paYCount;
	LONG paXExt;
	LONG paYExt;
	BYTE paRGBs;
} PELARRAY,*PPELARRAY,*LPPELARRAY;
typedef struct tagENUMLOGFONTA {
	LOGFONTA elfLogFont;
	BYTE elfFullName[LF_FULLFACESIZE];
	BYTE elfStyle[LF_FACESIZE];
} ENUMLOGFONTA,*LPENUMLOGFONTA;
typedef struct tagENUMLOGFONTW {
	LOGFONTW elfLogFont;
	WCHAR elfFullName[LF_FULLFACESIZE];
	WCHAR elfStyle[LF_FACESIZE];
} ENUMLOGFONTW,*LPENUMLOGFONTW;
typedef struct tagENUMLOGFONTEXA {
	LOGFONTA elfLogFont;
	BYTE elfFullName[LF_FULLFACESIZE];
	BYTE elfStyle[LF_FACESIZE];
	BYTE elfScript[LF_FACESIZE];
} ENUMLOGFONTEXA,*LPENUMLOGFONTEXA;
typedef struct tagENUMLOGFONTEXW {
	LOGFONTW elfLogFont;
	WCHAR elfFullName[LF_FULLFACESIZE];
	WCHAR elfStyle[LF_FACESIZE];
	WCHAR elfScript[LF_FACESIZE];
} ENUMLOGFONTEXW,*LPENUMLOGFONTEXW;
typedef struct tagPOINTFX {
	FIXED x;
	FIXED y;
} POINTFX,*LPPOINTFX;
typedef struct tagTTPOLYCURVE {
	WORD wType;
	WORD cpfx;
	POINTFX apfx[1];
} TTPOLYCURVE,*LPTTPOLYCURVE;
typedef struct tagTTPOLYGONHEADER {
	DWORD cb;
	DWORD dwType;
	POINTFX pfxStart;
} TTPOLYGONHEADER,*LPTTPOLYGONHEADER;
typedef struct _POINTFLOAT {
	FLOAT x;
	FLOAT y;
} POINTFLOAT,*PPOINTFLOAT;
typedef struct _GLYPHMETRICSFLOAT {
	FLOAT gmfBlackBoxX;
	FLOAT gmfBlackBoxY;
	POINTFLOAT gmfptGlyphOrigin;
	FLOAT gmfCellIncX;
	FLOAT gmfCellIncY;
} GLYPHMETRICSFLOAT,*PGLYPHMETRICSFLOAT,*LPGLYPHMETRICSFLOAT;
typedef struct tagLAYERPLANEDESCRIPTOR {
	WORD nSize;
	WORD nVersion;
	DWORD dwFlags;
	BYTE iPixelType;
	BYTE cColorBits;
	BYTE cRedBits;
	BYTE cRedShift;
	BYTE cGreenBits;
	BYTE cGreenShift;
	BYTE cBlueBits;
	BYTE cBlueShift;
	BYTE cAlphaBits;
	BYTE cAlphaShift;
	BYTE cAccumBits;
	BYTE cAccumRedBits;
	BYTE cAccumGreenBits;
	BYTE cAccumBlueBits;
	BYTE cAccumAlphaBits;
	BYTE cDepthBits;
	BYTE cStencilBits;
	BYTE cAuxBuffers;
	BYTE iLayerPlane;
	BYTE bReserved;
	COLORREF crTransparent;
} LAYERPLANEDESCRIPTOR,*PLAYERPLANEDESCRIPTOR,*LPLAYERPLANEDESCRIPTOR;
typedef struct _BLENDFUNCTION {
    BYTE BlendOp;
    BYTE BlendFlags;
    BYTE SourceConstantAlpha;
    BYTE AlphaFormat; 
} BLENDFUNCTION,*PBLENDFUNCTION,*LPBLENDFUNCTION; 
#define MM_MAX_NUMAXES  16
typedef struct _DESIGNVECTOR {
	DWORD dvReserved;
	DWORD dvNumAxes;
	LONG dvValues[MM_MAX_NUMAXES];
} DESIGNVECTOR, *PDESIGNVECTOR, FAR *LPDESIGNVECTOR;
#if _WIN32_WINNT >= 0x0500
typedef struct tagENUMLOGFONTEXDVA
{
	ENUMLOGFONTEXA elfEnumLogfontEx;
	DESIGNVECTOR elfDesignVector;
} ENUMLOGFONTEXDVA, *PENUMLOGFONTEXDVA, *LPENUMLOGFONTEXDVA;
typedef struct tagENUMLOGFONTEXDVW
{
	ENUMLOGFONTEXW elfEnumLogfontEx;
	DESIGNVECTOR elfDesignVector;
} ENUMLOGFONTEXDVW, *PENUMLOGFONTEXDVW, *LPENUMLOGFONTEXDVW;
#endif /* _WIN32_WINNT >= 0x0500 */
typedef USHORT COLOR16;
typedef struct _TRIVERTEX {
	LONG x;
	LONG y;
	COLOR16 Red;
	COLOR16 Green;
	COLOR16 Blue;
	COLOR16 Alpha;
} TRIVERTEX, *PTRIVERTEX, *LPTRIVERTEX;
typedef struct _GRADIENT_TRIANGLE {
	ULONG Vertex1;
	ULONG Vertex2;
	ULONG Vertex3;
} GRADIENT_TRIANGLE,*PGRADIENT_TRIANGLE,*LPGRADIENT_TRIANGLE;
typedef struct _GRADIENT_RECT {
	ULONG UpperLeft;
	ULONG LowerRight;
}GRADIENT_RECT,*PGRADIENT_RECT,*LPGRADIENT_RECT;
typedef struct _DISPLAY_DEVICEA {
  DWORD cb;
  CHAR DeviceName[32];
  CHAR DeviceString[128];
  DWORD StateFlags;
  CHAR DeviceID[128];
  CHAR DeviceKey[128];
} DISPLAY_DEVICEA, *PDISPLAY_DEVICEA, *LPDISPLAY_DEVICEA;
typedef struct _DISPLAY_DEVICEW {
  DWORD cb;
  WCHAR DeviceName[32];
  WCHAR DeviceString[128];
  DWORD StateFlags;
  WCHAR DeviceID[128];
  WCHAR DeviceKey[128];
} DISPLAY_DEVICEW, *PDISPLAY_DEVICEW, *LPDISPLAY_DEVICEW;

typedef BOOL (CALLBACK *ABORTPROC)(HDC,int);
typedef int (CALLBACK *MFENUMPROC)(HDC,HANDLETABLE*,METARECORD*,int,LPARAM);
typedef int (CALLBACK *ENHMFENUMPROC)(HDC,HANDLETABLE*,ENHMETARECORD*,int,LPARAM);
typedef int (CALLBACK *OLDFONTENUMPROCA)(const LOGFONTA*,const TEXTMETRICA*,DWORD,LPARAM);
typedef int (CALLBACK *OLDFONTENUMPROCW)(const LOGFONTW*,const TEXTMETRICW*,DWORD,LPARAM);
typedef OLDFONTENUMPROCA FONTENUMPROCA;
typedef OLDFONTENUMPROCW FONTENUMPROCW;
typedef int (CALLBACK *ICMENUMPROCA)(LPSTR,LPARAM);
typedef int (CALLBACK *ICMENUMPROCW)(LPWSTR,LPARAM);
typedef void (CALLBACK *GOBJENUMPROC)(LPVOID,LPARAM);
typedef void (CALLBACK *LINEDDAPROC)(int,int,LPARAM);
typedef UINT (CALLBACK *LPFNDEVMODE)(HWND,HMODULE,LPDEVMODEA,LPSTR,LPSTR,LPDEVMODEA,LPSTR,UINT);
typedef DWORD (CALLBACK *LPFNDEVCAPS)(LPSTR,LPSTR,UINT,LPSTR,LPDEVMODEA);

#define MAKEPOINTS(l) (*((POINTS*)&(l)))
#define MAKEROP4(f,b)	(DWORD)((((b)<<8)&0xFF000000)|(f))

#define GetCValue(cmyk) ((BYTE)(cmyk))
#define GetMValue(cmyk) ((BYTE)((cmyk)>> 8))
#define GetYValue(cmyk) ((BYTE)((cmyk)>>16))
#define GetKValue(cmyk) ((BYTE)((cmyk)>>24))
#define CMYK(c,m,y,k) ((COLORREF)((BYTE)(k)|((BYTE)(y)<<8)|((BYTE)(m)<<16)|((BYTE)(c)<<24)))

#define GetRValue(c) ((BYTE)(c))
#define GetGValue(c) ((BYTE)(((WORD)(c))>>8))
#define GetBValue(c) ((BYTE)((c)>>16))
#define RGB(r,g,b) ((COLORREF)((BYTE)(r)|((BYTE)(g) << 8)|((BYTE)(b) << 16)))

#define PALETTEINDEX(i)	((0x01000000|(COLORREF)(WORD)(i)))
#define PALETTERGB(r,g,b)	(0x02000000|RGB(r,g,b))

WINGDIAPI int WINAPI AbortDoc(HDC a){}
WINGDIAPI BOOL WINAPI AbortPath(HDC a){}
WINGDIAPI int WINAPI AddFontResourceA(LPCSTR a){}
WINGDIAPI int WINAPI AddFontResourceW(LPCWSTR a){}
#if (_WIN32_WINNT >= 0x0500)
WINGDIAPI HANDLE WINAPI AddFontMemResourceEx(PVOID a,DWORD b,PVOID c,DWORD * d){}
WINGDIAPI int WINAPI AddFontResourceExA(LPCSTR a,DWORD b,PVOID c){}
WINGDIAPI int WINAPI AddFontResourceExW(LPCWSTR a,DWORD b,PVOID c){}
#endif
WINGDIAPI BOOL WINAPI AngleArc(HDC a,int b,int c,DWORD d,FLOAT e,FLOAT f){}
WINGDIAPI BOOL WINAPI AnimatePalette(HPALETTE a,UINT b,UINT c,const PALETTEENTRY* d){}
WINGDIAPI BOOL WINAPI Arc(HDC a,int b,int c,int d,int e,int f,int g,int h,int i){}
WINGDIAPI BOOL WINAPI ArcTo(HDC a,int b,int c,int d,int e,int f,int g,int h,int i){}
WINGDIAPI BOOL WINAPI BeginPath(HDC a){}
WINGDIAPI BOOL WINAPI BitBlt(HDC a,int b,int c,int d,int e,HDC f,int g,int h,DWORD i){}
WINGDIAPI BOOL WINAPI CancelDC(HDC a){}
WINGDIAPI BOOL WINAPI CheckColorsInGamut(HDC a,PVOID b,PVOID c,DWORD d){}
WINGDIAPI BOOL WINAPI Chord(HDC a,int b,int c,int d,int e,int f,int g,int h,int i){}
WINGDIAPI int WINAPI ChoosePixelFormat(HDC a,CONST PIXELFORMATDESCRIPTOR* b){}
WINGDIAPI HENHMETAFILE WINAPI CloseEnhMetaFile(HDC a){}
WINGDIAPI BOOL WINAPI CloseFigure(HDC a){}
WINGDIAPI HMETAFILE WINAPI CloseMetaFile(HDC a){}
#if (_WIN32_WINDOWS >= 0x0410 || _WIN32_WINNT >= 0x0500)
WINGDIAPI BOOL WINAPI ColorCorrectPalette(HDC a,HPALETTE b,DWORD c,DWORD d){}
WINGDIAPI BOOL WINAPI ColorMatchToTarget(HDC a,HDC b,DWORD c){}
#endif
WINGDIAPI int WINAPI CombineRgn(HRGN a,HRGN b,HRGN c,int d){}
WINGDIAPI BOOL WINAPI CombineTransform(LPXFORM a,const XFORM* b,const XFORM* c){}
WINGDIAPI HENHMETAFILE WINAPI CopyEnhMetaFileA(HENHMETAFILE a,LPCSTR b){}
WINGDIAPI HENHMETAFILE WINAPI CopyEnhMetaFileW(HENHMETAFILE a,LPCWSTR b){}
WINGDIAPI HMETAFILE WINAPI CopyMetaFileA(HMETAFILE a,LPCSTR b){}
WINGDIAPI HMETAFILE WINAPI CopyMetaFileW(HMETAFILE a,LPCWSTR b){}
WINGDIAPI HBITMAP WINAPI CreateBitmap(int a,int b,UINT c,UINT d,PCVOID e){}
WINGDIAPI HBITMAP WINAPI CreateBitmapIndirect(const BITMAP* a){}
WINGDIAPI HBRUSH WINAPI CreateBrushIndirect(const LOGBRUSH* a){}
WINGDIAPI HCOLORSPACE WINAPI CreateColorSpaceA(LPLOGCOLORSPACEA a){}
WINGDIAPI HCOLORSPACE WINAPI CreateColorSpaceW(LPLOGCOLORSPACEW a){}
WINGDIAPI HBITMAP WINAPI CreateCompatibleBitmap(HDC a,int b,int c){}
WINGDIAPI HDC WINAPI CreateCompatibleDC(HDC a){}
WINGDIAPI HDC WINAPI CreateDCA(LPCSTR a,LPCSTR b,LPCSTR c,const DEVMODEA* d){}
WINGDIAPI HDC WINAPI CreateDCW(LPCWSTR a,LPCWSTR b,LPCWSTR c,const DEVMODEW* d){}
WINGDIAPI HBITMAP WINAPI CreateDIBitmap(HDC a,const BITMAPINFOHEADER* b,DWORD c,PCVOID d,const BITMAPINFO* e,UINT f){}
WINGDIAPI HBRUSH WINAPI CreateDIBPatternBrush(HGLOBAL a,UINT b){}
WINGDIAPI HBRUSH WINAPI CreateDIBPatternBrushPt(PCVOID a,UINT b){}
WINGDIAPI HBITMAP WINAPI CreateDIBSection(HDC a,const BITMAPINFO* b,UINT c,void** d,HANDLE e,DWORD f){}
WINGDIAPI HBITMAP WINAPI CreateDiscardableBitmap(HDC a,int b,int c){}
WINGDIAPI HRGN WINAPI CreateEllipticRgn(int a,int b,int c,int d){}
WINGDIAPI HRGN WINAPI CreateEllipticRgnIndirect(LPCRECT a){}
WINGDIAPI HDC WINAPI CreateEnhMetaFileA(HDC a,LPCSTR b,LPCRECT c,LPCSTR d){}
WINGDIAPI HDC WINAPI CreateEnhMetaFileW(HDC a,LPCWSTR b,LPCRECT c,LPCWSTR d){}
WINGDIAPI HFONT WINAPI CreateFontA(int a,int b,int c,int d,int e,DWORD f,DWORD g,DWORD h,DWORD i,DWORD j,DWORD k,DWORD l,DWORD m,LPCSTR n){}
WINGDIAPI HFONT WINAPI CreateFontW(int a,int b,int c,int d,int e,DWORD f,DWORD g,DWORD h,DWORD i,DWORD j,DWORD k,DWORD l,DWORD m,LPCWSTR n){}
WINGDIAPI HFONT WINAPI CreateFontIndirectA(const LOGFONTA* a){}
WINGDIAPI HFONT WINAPI CreateFontIndirectW(const LOGFONTW* a){}
WINGDIAPI HPALETTE WINAPI CreateHalftonePalette(HDC a){}
WINGDIAPI HBRUSH WINAPI CreateHatchBrush(int a,COLORREF b){}
WINGDIAPI HDC WINAPI CreateICA(LPCSTR a,LPCSTR b,LPCSTR c,const DEVMODEA* d){}
WINGDIAPI HDC WINAPI CreateICW(LPCWSTR a,LPCWSTR b,LPCWSTR c,const DEVMODEW* d){}
WINGDIAPI HDC WINAPI CreateMetaFileA(LPCSTR a){}
WINGDIAPI HDC WINAPI CreateMetaFileW(LPCWSTR a){}
WINGDIAPI HPALETTE WINAPI CreatePalette(const LOGPALETTE* a){}
WINGDIAPI HBRUSH WINAPI CreatePatternBrush(HBITMAP a){}
WINGDIAPI HPEN WINAPI CreatePen(int a,int b,COLORREF c){}
WINGDIAPI HPEN WINAPI CreatePenIndirect(const LOGPEN* a){}
WINGDIAPI HRGN WINAPI CreatePolygonRgn(const POINT* a,int b,int c){}
WINGDIAPI HRGN WINAPI CreatePolyPolygonRgn(const POINT* a,const INT* b,int c,int d){}
WINGDIAPI HRGN WINAPI CreateRectRgn(int a,int b,int c,int d){}
WINGDIAPI HRGN WINAPI CreateRectRgnIndirect(LPCRECT a){}
WINGDIAPI HRGN WINAPI CreateRoundRectRgn(int a,int b,int c,int d,int e,int f){}
WINGDIAPI BOOL WINAPI CreateScalableFontResourceA(DWORD a,LPCSTR b,LPCSTR c,LPCSTR d){}
WINGDIAPI BOOL WINAPI CreateScalableFontResourceW(DWORD a,LPCWSTR b,LPCWSTR c,LPCWSTR d){}
WINGDIAPI HBRUSH WINAPI CreateSolidBrush(COLORREF a){}
WINGDIAPI BOOL WINAPI DeleteColorSpace(HCOLORSPACE a){}
WINGDIAPI BOOL WINAPI DeleteDC(HDC a){}
WINGDIAPI BOOL WINAPI DeleteEnhMetaFile(HENHMETAFILE a){}
WINGDIAPI BOOL WINAPI DeleteMetaFile(HMETAFILE a){}
WINGDIAPI BOOL WINAPI DeleteObject(HGDIOBJ a){}
WINGDIAPI int WINAPI DescribePixelFormat(HDC a,int b,UINT c,LPPIXELFORMATDESCRIPTOR d){}
WINGDIAPI DWORD WINAPI DeviceCapabilitiesA(LPCSTR a,LPCSTR b,WORD c,LPSTR d,const DEVMODEA* e){}
WINGDIAPI DWORD WINAPI DeviceCapabilitiesW(LPCWSTR a,LPCWSTR b,WORD c,LPWSTR d,const DEVMODEW* e){}
WINGDIAPI BOOL WINAPI DPtoLP(HDC a,LPPOINT b,int c){}
WINGDIAPI int WINAPI DrawEscape(HDC a,int b,int c,LPCSTR d){}
WINGDIAPI BOOL WINAPI Ellipse(HDC a,int b,int c,int d,int e){}
WINGDIAPI int WINAPI EndDoc(HDC a){}
WINGDIAPI int WINAPI EndPage(HDC a){}
WINGDIAPI BOOL WINAPI EndPath(HDC a){}
WINGDIAPI BOOL WINAPI EnumEnhMetaFile(HDC a,HENHMETAFILE b,ENHMFENUMPROC c,PVOID d,LPCRECT e){}
WINGDIAPI int WINAPI EnumFontFamiliesA(HDC a,LPCSTR b,FONTENUMPROCA c,LPARAM d){}
WINGDIAPI int WINAPI EnumFontFamiliesW(HDC a,LPCWSTR b,FONTENUMPROCW c,LPARAM d){}
WINGDIAPI int WINAPI EnumFontFamiliesExA(HDC a,PLOGFONTA b,FONTENUMPROCA c,LPARAM d,DWORD e){}
WINGDIAPI int WINAPI EnumFontFamiliesExW(HDC a,PLOGFONTW b,FONTENUMPROCW c,LPARAM d,DWORD e){}
WINGDIAPI int WINAPI EnumFontsA(HDC a,LPCSTR b,FONTENUMPROCA c,LPARAM d){}
WINGDIAPI int WINAPI EnumFontsW(HDC a,LPCWSTR b,FONTENUMPROCW c,LPARAM d){}
WINGDIAPI int WINAPI EnumICMProfilesA(HDC a,ICMENUMPROCA b,LPARAM c){}
WINGDIAPI int WINAPI EnumICMProfilesW(HDC a,ICMENUMPROCW b,LPARAM c){}
WINGDIAPI BOOL WINAPI EnumMetaFile(HDC a,HMETAFILE b,MFENUMPROC c,LPARAM d){}
WINGDIAPI int WINAPI EnumObjects(HDC a,int b,GOBJENUMPROC c,LPARAM d){}
WINGDIAPI BOOL WINAPI EqualRgn(HRGN a,HRGN b){}
WINGDIAPI int WINAPI Escape(HDC a,int b,int c,LPCSTR d,PVOID e){}
WINGDIAPI int WINAPI ExcludeClipRect(HDC a,int b,int c,int d,int e){}
WINGDIAPI int WINAPI ExcludeUpdateRgn(HDC a,HWND b){}
WINGDIAPI HPEN WINAPI ExtCreatePen(DWORD a,DWORD b,const LOGBRUSH* c,DWORD d,const DWORD* e){}
WINGDIAPI HRGN WINAPI ExtCreateRegion(const XFORM* a,DWORD b,const RGNDATA* c){}
WINGDIAPI int WINAPI ExtEscape(HDC a,int b,int c,LPCSTR d,int e,LPSTR f){}
WINGDIAPI BOOL WINAPI ExtFloodFill(HDC a,int b,int c,COLORREF d,UINT e){}
WINGDIAPI int WINAPI ExtSelectClipRgn(HDC a,HRGN b,int c){}
WINGDIAPI BOOL WINAPI ExtTextOutA(HDC a,int b,int c,UINT d,LPCRECT e,LPCSTR f,UINT g,const INT* h){}
WINGDIAPI BOOL WINAPI ExtTextOutW(HDC a,int b,int c,UINT d,LPCRECT e,LPCWSTR f,UINT g,const INT* h){}
WINGDIAPI BOOL WINAPI FillPath(HDC a){}
WINGDIAPI int WINAPI FillRect(HDC a,LPCRECT b,HBRUSH c){}
WINGDIAPI int WINAPI FillRgn(HDC a,HRGN b,HBRUSH c){}
WINGDIAPI BOOL WINAPI FixBrushOrgEx(HDC a,int b,int c,LPPOINT d){}
WINGDIAPI BOOL WINAPI FlattenPath(HDC a){}
WINGDIAPI BOOL WINAPI FloodFill(HDC a,int b,int c,COLORREF d){}
WINGDIAPI BOOL WINAPI GdiComment(HDC a,UINT b,const BYTE* c){}
WINGDIAPI BOOL WINAPI GdiFlush(void){}
WINGDIAPI DWORD WINAPI GdiGetBatchLimit(void){}
WINGDIAPI DWORD WINAPI GdiSetBatchLimit(DWORD a){}
WINGDIAPI int WINAPI GetArcDirection(HDC a){}
WINGDIAPI BOOL WINAPI GetAspectRatioFilterEx(HDC a,LPSIZE b){}
WINGDIAPI LONG WINAPI GetBitmapBits(HBITMAP a,LONG b,PVOID c){}
WINGDIAPI BOOL WINAPI GetBitmapDimensionEx(HBITMAP a,LPSIZE b){}
WINGDIAPI COLORREF WINAPI GetBkColor(HDC a){}
WINGDIAPI int WINAPI GetBkMode(HDC a){}
WINGDIAPI UINT WINAPI GetBoundsRect(HDC a,LPRECT b,UINT c){}
WINGDIAPI BOOL WINAPI GetBrushOrgEx(HDC a,LPPOINT b){}
WINGDIAPI BOOL WINAPI GetCharABCWidthsA(HDC a,UINT b,UINT c,LPABC d){}
WINGDIAPI BOOL WINAPI GetCharABCWidthsW(HDC a,UINT b,UINT c,LPABC d){}
WINGDIAPI BOOL WINAPI GetCharABCWidthsFloatA(HDC a,UINT b,UINT c,LPABCFLOAT d){}
WINGDIAPI BOOL WINAPI GetCharABCWidthsFloatW(HDC a,UINT b,UINT c,LPABCFLOAT d){}
WINGDIAPI DWORD WINAPI GetCharacterPlacementA(HDC a,LPCSTR b,int c,int d,LPGCP_RESULTSA e,DWORD f){}
WINGDIAPI DWORD WINAPI GetCharacterPlacementW(HDC a,LPCWSTR b,int c,int d,LPGCP_RESULTSW e,DWORD f){}
WINGDIAPI BOOL WINAPI GetCharWidth32A(HDC a,UINT b,UINT c,LPINT d){}
WINGDIAPI BOOL WINAPI GetCharWidth32W(HDC a,UINT b,UINT c,LPINT d){}
WINGDIAPI BOOL WINAPI GetCharWidthA(HDC a,UINT b,UINT c,LPINT d){}
WINGDIAPI BOOL WINAPI GetCharWidthW(HDC a,UINT b,UINT c,LPINT d){}
WINGDIAPI BOOL WINAPI GetCharWidthFloatA(HDC a,UINT b,UINT c,PFLOAT d){}
WINGDIAPI BOOL WINAPI GetCharWidthFloatW(HDC a,UINT b,UINT c,PFLOAT d){}
WINGDIAPI int WINAPI GetClipBox(HDC a,LPRECT b){}
WINGDIAPI int WINAPI GetClipRgn(HDC a,HRGN b){}
WINGDIAPI BOOL WINAPI GetColorAdjustment(HDC a,LPCOLORADJUSTMENT b){}
WINGDIAPI HANDLE WINAPI GetColorSpace(HDC a){}
WINGDIAPI HGDIOBJ WINAPI GetCurrentObject(HDC a,UINT b){}
WINGDIAPI BOOL WINAPI GetCurrentPositionEx(HDC a,LPPOINT b){}
WINGDIAPI HCURSOR WINAPI GetCursor(void){}
#if (WINVER >= 0x0500)
WINGDIAPI COLORREF WINAPI GetDCBrushColor(HDC a){}
WINGDIAPI COLORREF WINAPI GetDCPenColor(HDC a){}
#endif
WINGDIAPI BOOL WINAPI GetDCOrgEx(HDC a,LPPOINT b){}
WINGDIAPI int WINAPI GetDeviceCaps(HDC a,int b){}
WINGDIAPI BOOL WINAPI GetDeviceGammaRamp(HDC a,PVOID b){}
WINGDIAPI UINT WINAPI GetDIBColorTable(HDC a,UINT b,UINT c,RGBQUAD* d){}
WINGDIAPI int WINAPI GetDIBits(HDC a,HBITMAP b,UINT c,UINT d,PVOID e,LPBITMAPINFO f,UINT g){}
WINGDIAPI HENHMETAFILE WINAPI GetEnhMetaFileA(LPCSTR a){}
WINGDIAPI HENHMETAFILE WINAPI GetEnhMetaFileW(LPCWSTR a){}
WINGDIAPI UINT WINAPI GetEnhMetaFileBits(HENHMETAFILE a,UINT b,LPBYTE c){}
WINGDIAPI UINT WINAPI GetEnhMetaFileDescriptionA(HENHMETAFILE a,UINT b,LPSTR c){}
WINGDIAPI UINT WINAPI GetEnhMetaFileDescriptionW(HENHMETAFILE a,UINT b,LPWSTR c){}
WINGDIAPI UINT WINAPI GetEnhMetaFileHeader(HENHMETAFILE a,UINT b,LPENHMETAHEADER c){}
WINGDIAPI UINT WINAPI GetEnhMetaFilePaletteEntries(HENHMETAFILE a,UINT b,LPPALETTEENTRY c){}
WINGDIAPI UINT WINAPI GetEnhMetaFilePixelFormat(HENHMETAFILE a,DWORD b,CONST PIXELFORMATDESCRIPTOR* c){}
WINGDIAPI DWORD WINAPI GetFontData(HDC a,DWORD b,DWORD c,PVOID d,DWORD e){}
WINGDIAPI DWORD WINAPI GetFontLanguageInfo(HDC a){}
WINGDIAPI DWORD WINAPI GetGlyphOutlineA(HDC a,UINT b,UINT c,LPGLYPHMETRICS d,DWORD e,PVOID f,const MAT2* g){}
WINGDIAPI DWORD WINAPI GetGlyphOutlineW(HDC a,UINT b,UINT c,LPGLYPHMETRICS d,DWORD e,PVOID f,const MAT2* g){}
WINGDIAPI int WINAPI GetGraphicsMode(HDC a){}
WINGDIAPI BOOL WINAPI GetICMProfileA(HDC a,LPDWORD b,LPSTR c){}
WINGDIAPI BOOL WINAPI GetICMProfileW(HDC a,LPDWORD b,LPWSTR c){}
WINGDIAPI DWORD WINAPI GetKerningPairsA(HDC a,DWORD b,LPKERNINGPAIR c){}
WINGDIAPI DWORD WINAPI GetKerningPairsW(HDC a,DWORD b,LPKERNINGPAIR c){}
WINGDIAPI BOOL WINAPI GetLogColorSpaceA(HCOLORSPACE a,LPLOGCOLORSPACEA b,DWORD c){}
WINGDIAPI BOOL WINAPI GetLogColorSpaceW(HCOLORSPACE a,LPLOGCOLORSPACEW b,DWORD c){}
WINGDIAPI int WINAPI GetMapMode(HDC a){}
WINGDIAPI HMETAFILE WINAPI GetMetaFileA(LPCSTR a){}
WINGDIAPI HMETAFILE WINAPI GetMetaFileW(LPCWSTR a){}
WINGDIAPI UINT WINAPI GetMetaFileBitsEx(HMETAFILE a,UINT b,PVOID c){}
WINGDIAPI int WINAPI GetMetaRgn(HDC a,HRGN b){}
WINGDIAPI BOOL WINAPI GetMiterLimit(HDC a,PFLOAT b){}
WINGDIAPI COLORREF WINAPI GetNearestColor(HDC a,COLORREF b){}
WINGDIAPI UINT WINAPI GetNearestPaletteIndex(HPALETTE a,COLORREF b){}
WINGDIAPI int WINAPI GetObjectA(HGDIOBJ a,int b,PVOID c){}
WINGDIAPI int WINAPI GetObjectW(HGDIOBJ a,int b,PVOID c){}
WINGDIAPI DWORD WINAPI GetObjectType(HGDIOBJ a){}
WINGDIAPI UINT WINAPI GetOutlineTextMetricsA(HDC a,UINT b,LPOUTLINETEXTMETRICA c){}
WINGDIAPI UINT WINAPI GetOutlineTextMetricsW(HDC a,UINT b,LPOUTLINETEXTMETRICW c){}
WINGDIAPI UINT WINAPI GetPaletteEntries(HPALETTE a,UINT b,UINT c,LPPALETTEENTRY d){}
WINGDIAPI int WINAPI GetPath(HDC a,LPPOINT b,PBYTE c,int d){}
WINGDIAPI COLORREF WINAPI GetPixel(HDC a,int b,int c){}
WINGDIAPI int WINAPI GetPixelFormat(HDC a){}
WINGDIAPI int WINAPI GetPolyFillMode(HDC a){}
WINGDIAPI BOOL WINAPI GetRasterizerCaps(LPRASTERIZER_STATUS a,UINT b){}
WINGDIAPI int WINAPI GetRandomRgn (HDC a,HRGN b,INT c){}
WINGDIAPI DWORD WINAPI GetRegionData(HRGN a,DWORD b,LPRGNDATA c){}
WINGDIAPI int WINAPI GetRgnBox(HRGN a,LPRECT b){}
WINGDIAPI int WINAPI GetROP2(HDC a){}
WINGDIAPI HGDIOBJ WINAPI GetStockObject(int a){}
WINGDIAPI int WINAPI GetStretchBltMode(HDC a){}
WINGDIAPI UINT WINAPI GetSystemPaletteEntries(HDC a,UINT b,UINT c,LPPALETTEENTRY d){}
WINGDIAPI UINT WINAPI GetSystemPaletteUse(HDC a){}
WINGDIAPI UINT WINAPI GetTextAlign(HDC a){}
WINGDIAPI int WINAPI GetTextCharacterExtra(HDC a){}
WINGDIAPI int WINAPI GetTextCharset(HDC a){}
WINGDIAPI int WINAPI GetTextCharsetInfo(HDC a,LPFONTSIGNATURE b,DWORD c){}
WINGDIAPI COLORREF WINAPI GetTextColor(HDC a){}
WINGDIAPI BOOL WINAPI GetTextExtentExPointA(HDC a,LPCSTR b,int c,int d,LPINT e,LPINT f,LPSIZE g){}
WINGDIAPI BOOL WINAPI GetTextExtentExPointW( HDC a,LPCWSTR b,int c,int d,LPINT e,LPINT f,LPSIZE  g){}
WINGDIAPI BOOL WINAPI GetTextExtentPointA(HDC a,LPCSTR b,int c,LPSIZE d){}
WINGDIAPI BOOL WINAPI GetTextExtentPointW(HDC a,LPCWSTR b,int c,LPSIZE d){}
#if (_WIN32_WINNT >= 0x0500)
WINGDIAPI BOOL WINAPI GetTextExtentExPointI(HDC a, LPWORD b, int c, int d, LPINT e, LPINT f, LPSIZE g){}
#endif
#ifdef _WIN32_WCE
extern BOOL GetTextExtentPoint32A(HDC,LPCSTR,int,LPSIZE);
extern BOOL GetTextExtentPoint32W( HDC,LPCWSTR,int,LPSIZE);
#else
WINGDIAPI BOOL WINAPI GetTextExtentPoint32A(HDC a,LPCSTR b,int c,LPSIZE d){}
WINGDIAPI BOOL WINAPI GetTextExtentPoint32W( HDC a,LPCWSTR b,int c,LPSIZE d){}
#endif
WINGDIAPI int WINAPI GetTextFaceA(HDC a,int b,LPSTR c){}
WINGDIAPI int WINAPI GetTextFaceW(HDC a,int b,LPWSTR c){}
WINGDIAPI BOOL WINAPI GetTextMetricsA(HDC a,LPTEXTMETRICA b){}
WINGDIAPI BOOL WINAPI GetTextMetricsW(HDC a,LPTEXTMETRICW b){}
WINGDIAPI BOOL WINAPI GetViewportExtEx(HDC a,LPSIZE b){}
WINGDIAPI BOOL WINAPI GetViewportOrgEx(HDC a,LPPOINT b){}
WINGDIAPI BOOL WINAPI GetWindowExtEx(HDC a,LPSIZE b){}
WINGDIAPI BOOL WINAPI GetWindowOrgEx(HDC a,LPPOINT b){}
WINGDIAPI UINT WINAPI GetWinMetaFileBits(HENHMETAFILE a,UINT b,LPBYTE c,INT d,HDC e){}
WINGDIAPI BOOL WINAPI GetWorldTransform(HDC a,LPXFORM b){}
WINGDIAPI int WINAPI IntersectClipRect(HDC a,int b,int c,int d,int e){}
WINGDIAPI BOOL WINAPI InvertRgn(HDC a,HRGN b){}
WINGDIAPI BOOL WINAPI LineDDA(int a,int b,int c,int d,LINEDDAPROC e,LPARAM f){}
WINGDIAPI BOOL WINAPI LineTo(HDC a,int b,int c){}
WINGDIAPI BOOL WINAPI LPtoDP(HDC a,LPPOINT b,int c){}
WINGDIAPI BOOL WINAPI MaskBlt(HDC a,int b,int c,int d,int e,HDC f,int g,int h,HBITMAP i,int j,int k,DWORD l){}
WINGDIAPI BOOL WINAPI ModifyWorldTransform(HDC a,const XFORM* b,DWORD c){}
WINGDIAPI BOOL WINAPI MoveToEx(HDC a,int b,int c,LPPOINT d){}
WINGDIAPI int WINAPI OffsetClipRgn(HDC a,int b,int c){}
WINGDIAPI int WINAPI OffsetRgn(HRGN a,int b,int c){}
WINGDIAPI BOOL WINAPI OffsetViewportOrgEx(HDC a,int b,int c,LPPOINT d){}
WINGDIAPI BOOL WINAPI OffsetWindowOrgEx(HDC a,int b,int c,LPPOINT d){}
WINGDIAPI BOOL WINAPI PaintRgn(HDC a,HRGN b){}
WINGDIAPI BOOL WINAPI PatBlt(HDC a,int b,int c,int d,int e,DWORD f){}
WINGDIAPI HRGN WINAPI PathToRegion(HDC a){}
WINGDIAPI BOOL WINAPI Pie(HDC a,int b,int c,int d,int e,int f,int g,int h,int i){}
WINGDIAPI BOOL WINAPI PlayEnhMetaFile(HDC a,HENHMETAFILE b,LPCRECT c){}
WINGDIAPI BOOL WINAPI PlayEnhMetaFileRecord(HDC a,LPHANDLETABLE b,const ENHMETARECORD* c,UINT d){}
WINGDIAPI BOOL WINAPI PlayMetaFile(HDC a,HMETAFILE b){}
WINGDIAPI BOOL WINAPI PlayMetaFileRecord(HDC a,LPHANDLETABLE b,LPMETARECORD c,UINT d){}
WINGDIAPI BOOL WINAPI PlgBlt(HDC a,const POINT* b,HDC c,int d,int e,int f,int g,HBITMAP h,int i,int j){}
WINGDIAPI BOOL WINAPI PolyBezier(HDC a,const POINT* b,DWORD c){}
WINGDIAPI BOOL WINAPI PolyBezierTo(HDC a,const POINT* b,DWORD c){}
WINGDIAPI BOOL WINAPI PolyDraw(HDC a,const POINT* b,const BYTE* c,int d){}
WINGDIAPI BOOL WINAPI Polygon(HDC a,const POINT* b,int c){}
WINGDIAPI BOOL WINAPI Polyline(HDC a,const POINT* b,int c){}
WINGDIAPI BOOL WINAPI PolylineTo(HDC a,const POINT* b,DWORD c){}
WINGDIAPI BOOL WINAPI PolyPolygon(HDC a,const POINT* b,const INT* c,int d){}
WINGDIAPI BOOL WINAPI PolyPolyline(HDC a,const POINT* b,const DWORD* c,DWORD d){}
WINGDIAPI BOOL WINAPI PolyTextOutA(HDC a,const POLYTEXTA* b,int c){}
WINGDIAPI BOOL WINAPI PolyTextOutW(HDC a,const POLYTEXTW* b,int c){}
WINGDIAPI BOOL WINAPI PtInRegion(HRGN a,int b,int c){}
WINGDIAPI BOOL WINAPI PtVisible(HDC a,int b,int c){}
WINGDIAPI UINT WINAPI RealizePalette(HDC a){}
WINGDIAPI BOOL WINAPI Rectangle(HDC a,int b,int c,int d,int e){}
WINGDIAPI BOOL WINAPI RectInRegion(HRGN a,LPCRECT b){}
WINGDIAPI BOOL WINAPI RectVisible(HDC a,LPCRECT b){}
WINGDIAPI BOOL WINAPI RemoveFontResourceA(LPCSTR a){}
WINGDIAPI BOOL WINAPI RemoveFontResourceW(LPCWSTR a){}
#if (_WIN32_WINNT >= 0x0500)
WINGDIAPI BOOL WINAPI RemoveFontMemResourceEx(HANDLE a){}
WINGDIAPI BOOL WINAPI RemoveFontResourceExA(LPCSTR a,DWORD b,PVOID c){}
WINGDIAPI BOOL WINAPI RemoveFontResourceExW(LPCWSTR a,DWORD b,PVOID c){}
#endif
WINGDIAPI HDC WINAPI ResetDCA(HDC a,const DEVMODEA* b){}
WINGDIAPI HDC WINAPI ResetDCW(HDC a,const DEVMODEW* b){}
WINGDIAPI BOOL WINAPI ResizePalette(HPALETTE a,UINT b){}
WINGDIAPI BOOL WINAPI RestoreDC(HDC a,int b){}
WINGDIAPI BOOL WINAPI RoundRect(HDC a,int b,int c,int d,int e,int f,int g){}
WINGDIAPI int WINAPI SaveDC(HDC a){}
WINGDIAPI BOOL WINAPI ScaleViewportExtEx(HDC a,int b,int c,int d,int e,LPSIZE f){}
WINGDIAPI BOOL WINAPI ScaleWindowExtEx(HDC a,int b,int c,int d,int e,LPSIZE f){}
WINGDIAPI BOOL WINAPI SelectClipPath(HDC a,int b){}
WINGDIAPI int WINAPI SelectClipRgn(HDC a,HRGN b){}
WINGDIAPI HGDIOBJ WINAPI SelectObject(HDC a,HGDIOBJ b){}
WINGDIAPI HPALETTE WINAPI SelectPalette(HDC a,HPALETTE b,BOOL c){}
WINGDIAPI int WINAPI SetAbortProc(HDC a,ABORTPROC b){}
WINGDIAPI int WINAPI SetArcDirection(HDC a,int b){}
WINGDIAPI LONG WINAPI SetBitmapBits(HBITMAP a,DWORD b,PCVOID c){}
WINGDIAPI BOOL WINAPI SetBitmapDimensionEx(HBITMAP a,int b,int c,LPSIZE d){}
WINGDIAPI COLORREF WINAPI SetBkColor(HDC a,COLORREF b){}
WINGDIAPI int WINAPI SetBkMode(HDC a,int b){}
WINGDIAPI UINT WINAPI SetBoundsRect(HDC a,LPCRECT b,UINT c){}
WINGDIAPI BOOL WINAPI SetBrushOrgEx(HDC a,int b,int c,LPPOINT d){}
WINGDIAPI BOOL WINAPI SetColorAdjustment(HDC a,const COLORADJUSTMENT* b){}
WINGDIAPI BOOL WINAPI SetColorSpace(HDC a,HCOLORSPACE b){}
#if (_WIN32_WINNT >= 0x0500)
WINGDIAPI COLORREF WINAPI SetDCBrushColor(HDC a,COLORREF b){}
WINGDIAPI COLORREF WINAPI SetDCPenColor(HDC a,COLORREF b){}
#endif
WINGDIAPI BOOL WINAPI SetDeviceGammaRamp(HDC a,PVOID b){}
WINGDIAPI UINT WINAPI SetDIBColorTable(HDC a,UINT b,UINT c,const RGBQUAD* d){}
WINGDIAPI int WINAPI SetDIBits(HDC a,HBITMAP b,UINT c,UINT d,PCVOID e,const BITMAPINFO* f,UINT g){}
WINGDIAPI int WINAPI SetDIBitsToDevice(HDC a,int b,int c,DWORD d,DWORD e,int f,int g,UINT h,UINT i,PCVOID j,const BITMAPINFO* k,UINT l){}
WINGDIAPI HENHMETAFILE WINAPI SetEnhMetaFileBits(UINT a,const BYTE* b){}
WINGDIAPI int WINAPI SetGraphicsMode(HDC a,int b){}
WINGDIAPI int WINAPI SetICMMode(HDC a,int b){}
WINGDIAPI BOOL WINAPI SetICMProfileA(HDC a,LPSTR b){}
WINGDIAPI BOOL WINAPI SetICMProfileW(HDC a,LPWSTR b){}
WINGDIAPI int WINAPI SetMapMode(HDC a,int b){}
WINGDIAPI DWORD WINAPI SetMapperFlags(HDC a,DWORD b){}
WINGDIAPI HMETAFILE WINAPI SetMetaFileBitsEx(UINT a,const BYTE * b){}
WINGDIAPI int WINAPI SetMetaRgn(HDC a){}
WINGDIAPI BOOL WINAPI SetMiterLimit(HDC a,FLOAT b,PFLOAT c){}
WINGDIAPI UINT WINAPI SetPaletteEntries(HPALETTE a,UINT b,UINT c,const PALETTEENTRY* d){}
WINGDIAPI COLORREF WINAPI SetPixel(HDC a,int b,int c,COLORREF d){}
WINGDIAPI BOOL WINAPI SetPixelFormat(HDC a,int b,const PIXELFORMATDESCRIPTOR* c){}
WINGDIAPI BOOL WINAPI SetPixelV(HDC a,int b,int c,COLORREF d){}
WINGDIAPI int WINAPI SetPolyFillMode(HDC a,int b){}
WINGDIAPI BOOL WINAPI SetRectRgn(HRGN a,int b,int c,int d,int e){}
WINGDIAPI int WINAPI SetROP2(HDC a,int b){}
WINGDIAPI int WINAPI SetStretchBltMode(HDC a,int b){}
WINGDIAPI UINT WINAPI SetSystemPaletteUse(HDC a,UINT b){}
WINGDIAPI UINT WINAPI SetTextAlign(HDC a,UINT b){}
WINGDIAPI int WINAPI SetTextCharacterExtra(HDC a,int b){}
WINGDIAPI COLORREF WINAPI SetTextColor(HDC a,COLORREF b){}
WINGDIAPI BOOL WINAPI SetTextJustification(HDC a,int b,int c){}
WINGDIAPI BOOL WINAPI SetViewportExtEx(HDC a,int b,int c,LPSIZE d){}
WINGDIAPI BOOL WINAPI SetViewportOrgEx(HDC a,int b,int c,LPPOINT d){}
WINGDIAPI BOOL WINAPI SetWindowExtEx(HDC a,int b,int c,LPSIZE d){}
WINGDIAPI BOOL WINAPI SetWindowOrgEx(HDC a,int b,int c,LPPOINT d){}
WINGDIAPI HENHMETAFILE WINAPI SetWinMetaFileBits(UINT a,const BYTE* b,HDC c,const METAFILEPICT* d){}
WINGDIAPI BOOL WINAPI SetWorldTransform(HDC a,const XFORM * b){}
WINGDIAPI int WINAPI StartDocA(HDC a,const DOCINFOA* b){}
WINGDIAPI int WINAPI StartDocW(HDC a,const DOCINFOW* b){}
WINGDIAPI int WINAPI StartPage(HDC a){}
WINGDIAPI BOOL WINAPI StretchBlt(HDC a,int b,int c,int d,int e,HDC f,int g,int h,int i,int j,DWORD k){}
WINGDIAPI int WINAPI StretchDIBits(HDC a,int b,int c,int d,int e,int f,int g,int h,int i,const VOID * j,const BITMAPINFO * k,UINT l,DWORD m){}
WINGDIAPI BOOL WINAPI StrokeAndFillPath(HDC a){}
WINGDIAPI BOOL WINAPI StrokePath(HDC a){}
WINGDIAPI BOOL WINAPI SwapBuffers(HDC a){}
WINGDIAPI BOOL WINAPI TextOutA(HDC a,int b,int c,LPCSTR d,int e){}
WINGDIAPI BOOL WINAPI TextOutW(HDC a,int b,int c,LPCWSTR d,int e){}
WINGDIAPI BOOL WINAPI TranslateCharsetInfo(PDWORD a,LPCHARSETINFO b,DWORD c){}
WINGDIAPI BOOL WINAPI UnrealizeObject(HGDIOBJ a){}
WINGDIAPI BOOL WINAPI UpdateColors(HDC a){}
WINGDIAPI BOOL WINAPI UpdateICMRegKeyA(DWORD a,DWORD b,LPSTR c,UINT d){}
WINGDIAPI BOOL WINAPI UpdateICMRegKeyW(DWORD a,DWORD b,LPWSTR c,UINT d){}
WINGDIAPI BOOL WINAPI WidenPath(HDC a){}
WINGDIAPI BOOL WINAPI wglCopyContext(HGLRC a,HGLRC b,UINT c){}
WINGDIAPI HGLRC WINAPI wglCreateContext(HDC a){}
WINGDIAPI HGLRC WINAPI wglCreateLayerContext(HDC a,int b){}
WINGDIAPI BOOL WINAPI wglDeleteContext(HGLRC a){}
WINGDIAPI BOOL WINAPI wglDescribeLayerPlane(HDC a,int b,int c,UINT d,LPLAYERPLANEDESCRIPTOR e){}
WINGDIAPI HGLRC WINAPI wglGetCurrentContext(void){}
WINGDIAPI HDC WINAPI wglGetCurrentDC(void){}
WINGDIAPI int WINAPI wglGetLayerPaletteEntries(HDC a,int b,int c,int d,COLORREF* e){}
WINGDIAPI PROC WINAPI wglGetProcAddress(LPCSTR a){}
WINGDIAPI BOOL WINAPI wglMakeCurrent(HDC a,HGLRC b){}
WINGDIAPI BOOL WINAPI wglRealizeLayerPalette(HDC a,int b,BOOL c){}
WINGDIAPI int WINAPI wglSetLayerPaletteEntries(HDC a,int b,int c,int d,const COLORREF* e){}
WINGDIAPI BOOL WINAPI wglShareLists(HGLRC a,HGLRC b){}
WINGDIAPI BOOL WINAPI wglSwapLayerBuffers(HDC a,UINT b){}
WINGDIAPI BOOL WINAPI wglUseFontBitmapsA(HDC a,DWORD b,DWORD c,DWORD d){}
WINGDIAPI BOOL WINAPI wglUseFontBitmapsW(HDC a,DWORD b,DWORD c,DWORD d){}
WINGDIAPI BOOL WINAPI wglUseFontOutlinesA(HDC a,DWORD b,DWORD c,DWORD d,FLOAT e,FLOAT f,int g,LPGLYPHMETRICSFLOAT h){}
WINGDIAPI BOOL WINAPI wglUseFontOutlinesW(HDC a,DWORD b,DWORD c,DWORD d,FLOAT e,FLOAT f,int g,LPGLYPHMETRICSFLOAT h){}
#if (WINVER >= 0x0410)
WINGDIAPI BOOL WINAPI AlphaBlend(HDC a,int b,int c,int d,int e,HDC f,int g,int h,int i,int j,BLENDFUNCTION k){}
WINGDIAPI BOOL WINAPI GradientFill(HDC a,PTRIVERTEX b,ULONG c,PVOID d,ULONG e,ULONG f){}
WINGDIAPI BOOL WINAPI TransparentBlt(HDC a,int b,int c,int d,int e,HDC f,int g,int h,int i,int j,UINT k){}
#endif
#if (_WIN32_WINNT >= 0x0500)
WINGDIAPI DWORD WINAPI GetFontUnicodeRanges(HDC a,LPGLYPHSET b){}
WINGDIAPI DWORD WINAPI GetGlyphIndicesA(HDC a,LPCSTR b,int c,LPWORD d,DWORD e){}
WINGDIAPI DWORD WINAPI GetGlyphIndicesW(HDC a,LPCWSTR b,int c,LPWORD d,DWORD e){}
#endif
#if (WINVER >= 0x0500)
WINGDIAPI DWORD WINAPI GetLayout(HDC a){}
WINGDIAPI DWORD WINAPI SetLayout(HDC a, DWORD b){}
#endif

#ifdef UNICODE
typedef WCHAR BCHAR;
typedef DOCINFOW DOCINFO, *LPDOCINFO;
typedef LOGFONTW LOGFONT,*PLOGFONT,*LPLOGFONT;
typedef TEXTMETRICW TEXTMETRIC,*PTEXTMETRIC,*LPTEXTMETRIC;
#define ICMENUMPROC ICMENUMPROCW
#define FONTENUMPROC FONTENUMPROCW
typedef DEVMODEW DEVMODE,*PDEVMODE,*LPDEVMODE;
#if _WIN32_WINNT >= 0x0500
typedef ENUMLOGFONTEXDVW ENUMLOGFONTEXDV;
typedef PENUMLOGFONTEXDVW PENUMLOGFONTEXDV;
typedef LPENUMLOGFONTEXDVW LPENUMLOGFONTEXDV;
#endif
typedef EXTLOGFONTW EXTLOGFONT,*PEXTLOGFONT,*LPEXTLOGFONT;
typedef GCP_RESULTSW GCP_RESULTS,*LPGCP_RESULTS;
typedef OUTLINETEXTMETRICW OUTLINETEXTMETRIC,*POUTLINETEXTMETRIC,*LPOUTLINETEXTMETRIC;
typedef POLYTEXTW POLYTEXT,*PPOLYTEXT,*LPPOLYTEXT;
typedef LOGCOLORSPACEW LOGCOLORSPACE,*LPLOGCOLORSPACE;
typedef NEWTEXTMETRICW NEWTEXTMETRIC,*PNEWTEXTMETRIC,*LPNEWTEXTMETRIC;
typedef NEWTEXTMETRICEXW NEWTEXTMETRICEX;
typedef ENUMLOGFONTW ENUMLOGFONT,*LPENUMLOGFONT;
typedef ENUMLOGFONTEXW ENUMLOGFONTEX,*LPENUMLOGFONTEX;
typedef DISPLAY_DEVICEW DISPLAY_DEVICE, *PDISPLAY_DEVICE, *LPDISPLAY_DEVICE;
#define AddFontResource AddFontResourceW
#if (_WIN32_WINNT >= 0x0500)
#define AddFontResourceEx AddFontResourceExW
#endif
#define CopyEnhMetaFile CopyEnhMetaFileW
#define CopyMetaFile CopyMetaFileW
#define CreateColorSpace CreateColorSpaceW
#define CreateDC CreateDCW
#define CreateEnhMetaFile CreateEnhMetaFileW
#define CreateFont CreateFontW
#define CreateFontIndirect CreateFontIndirectW
#define CreateIC CreateICW
#define CreateMetaFile CreateMetaFileW
#define CreateScalableFontResource CreateScalableFontResourceW
#define DeviceCapabilities DeviceCapabilitiesW
#define EnumFontFamilies EnumFontFamiliesW
#define EnumFontFamiliesEx EnumFontFamiliesExW
#define EnumFonts EnumFontsW
#define EnumICMProfiles EnumICMProfilesW
#define ExtTextOut ExtTextOutW
#define GetCharABCWidthsFloat GetCharABCWidthsFloatW
#define GetCharABCWidths GetCharABCWidthsW
#define GetCharacterPlacement GetCharacterPlacementW
#define GetCharWidth32 GetCharWidth32W
#define GetCharWidthFloat GetCharWidthFloatW
#define GetCharWidth GetCharWidthW
#define GetEnhMetaFile GetEnhMetaFileW
#define GetEnhMetaFileDescription GetEnhMetaFileDescriptionW
#define GetGlyphOutline GetGlyphOutlineW
#define GetICMProfile GetICMProfileW
#define GetKerningPairs GetKerningPairsW
#define GetLogColorSpace GetLogColorSpaceW
#define GetMetaFile GetMetaFileW
#define GetObject GetObjectW
#define GetOutlineTextMetrics GetOutlineTextMetricsW
#define GetTextExtentPoint GetTextExtentPointW
#define GetTextExtentExPoint GetTextExtentExPointW
#define GetTextExtentPoint32 GetTextExtentPoint32W
#define GetTextFace GetTextFaceW
#define GetTextMetrics GetTextMetricsW
#define PolyTextOut PolyTextOutW
#define RemoveFontResource RemoveFontResourceW
#if (_WIN32_WINNT >= 0x0500)
#define RemoveFontResourceEx RemoveFontResourceExW
#endif
#define ResetDC ResetDCW
#define SetICMProfile SetICMProfileW
#define StartDoc StartDocW
#define TextOut TextOutW
#define UpdateICMRegKey UpdateICMRegKeyW
#define wglUseFontBitmaps wglUseFontBitmapsW
#define wglUseFontOutlines wglUseFontOutlinesW
#if (_WIN32_WINNT >= 0x0500)
#define GetGlyphIndices  GetGlyphIndicesW
#endif
#else  /* UNICODE */
typedef BYTE BCHAR;
typedef DOCINFOA DOCINFO, *LPDOCINFO;
typedef LOGFONTA LOGFONT,*PLOGFONT,*LPLOGFONT;
typedef TEXTMETRICA TEXTMETRIC,*PTEXTMETRIC,*LPTEXTMETRIC;
#define ICMENUMPROC ICMENUMPROCA
#define FONTENUMPROC FONTENUMPROCA
typedef DEVMODEA DEVMODE,*PDEVMODE,*LPDEVMODE;
#if _WIN32_WINNT >= 0x0500
typedef ENUMLOGFONTEXDVA ENUMLOGFONTEXDV;
typedef PENUMLOGFONTEXDVA PENUMLOGFONTEXDV;
typedef LPENUMLOGFONTEXDVA LPENUMLOGFONTEXDV;
#endif
typedef EXTLOGFONTA EXTLOGFONT,*PEXTLOGFONT,*LPEXTLOGFONT;
typedef GCP_RESULTSA GCP_RESULTS,*LPGCP_RESULTS;
typedef OUTLINETEXTMETRICA OUTLINETEXTMETRIC,*POUTLINETEXTMETRIC,*LPOUTLINETEXTMETRIC;
typedef POLYTEXTA POLYTEXT,*PPOLYTEXT,*LPPOLYTEXT;
typedef LOGCOLORSPACEA LOGCOLORSPACE,*LPLOGCOLORSPACE;
typedef NEWTEXTMETRICA NEWTEXTMETRIC,*PNEWTEXTMETRIC,*LPNEWTEXTMETRIC;
typedef NEWTEXTMETRICEXA NEWTEXTMETRICEX;
typedef ENUMLOGFONTA ENUMLOGFONT,*LPENUMLOGFONT;
typedef ENUMLOGFONTEXA ENUMLOGFONTEX,*LPENUMLOGFONTEX;
typedef DISPLAY_DEVICEA DISPLAY_DEVICE, *PDISPLAY_DEVICE, *LPDISPLAY_DEVICE;
#define AddFontResource AddFontResourceA
#if (_WIN32_WINNT >= 0x0500)
#define AddFontResourceEx AddFontResourceExA
#endif
#define CopyEnhMetaFile CopyEnhMetaFileA
#define CopyMetaFile CopyMetaFileA
#define CreateColorSpace CreateColorSpaceA
#define CreateDC CreateDCA
#define CreateEnhMetaFile CreateEnhMetaFileA
#define CreateFont CreateFontA
#define CreateFontIndirect CreateFontIndirectA
#define CreateIC CreateICA
#define CreateMetaFile CreateMetaFileA
#define CreateScalableFontResource CreateScalableFontResourceA
#define DeviceCapabilities DeviceCapabilitiesA
#define EnumFontFamilies EnumFontFamiliesA
#define EnumFontFamiliesEx EnumFontFamiliesExA
#define EnumFonts EnumFontsA
#define EnumICMProfiles EnumICMProfilesA
#define ExtTextOut ExtTextOutA
#define GetCharWidthFloat GetCharWidthFloatA
#define GetCharWidth GetCharWidthA
#define GetCharacterPlacement GetCharacterPlacementA
#define GetCharABCWidths GetCharABCWidthsA
#define GetCharABCWidthsFloat GetCharABCWidthsFloatA
#define GetCharWidth32 GetCharWidth32A
#define GetEnhMetaFile GetEnhMetaFileA
#define GetEnhMetaFileDescription GetEnhMetaFileDescriptionA
#define GetGlyphOutline GetGlyphOutlineA
#define GetICMProfile GetICMProfileA
#define GetKerningPairs GetKerningPairsA
#define GetLogColorSpace GetLogColorSpaceA
#define GetMetaFile GetMetaFileA
#define GetObject GetObjectA
#define GetOutlineTextMetrics GetOutlineTextMetricsA
#define GetTextExtentPoint GetTextExtentPointA
#define GetTextExtentExPoint GetTextExtentExPointA
#define GetTextExtentPoint32 GetTextExtentPoint32A
#define GetTextFace GetTextFaceA
#define GetTextMetrics GetTextMetricsA
#define PolyTextOut PolyTextOutA
#define RemoveFontResource RemoveFontResourceA
#if (_WIN32_WINNT >= 0x0500)
#define RemoveFontResourceEx RemoveFontResourceExA
#endif
#define ResetDC ResetDCA
#define SetICMProfile SetICMProfileA
#define StartDoc StartDocA
#define TextOut TextOutA
#define UpdateICMRegKey UpdateICMRegKeyA
#define wglUseFontBitmaps wglUseFontBitmapsA
#define wglUseFontOutlines wglUseFontOutlinesA
#if (_WIN32_WINNT >= 0x0500)
#define GetGlyphIndices  GetGlyphIndicesA
#endif
#endif /* UNICODE */
#endif /* RC_INVOKED */
#ifdef __cplusplus
}
#endif
#endif
